--[[ Chaos Cards, for SRB2:CE v4

CONSIDERING TODO:
    - make it so lava boost stops when you hit goop, or at least gives you back control
    - maybe unlock a second custom button to use?
    - allow the custom button to be rebound to things like tossflag and etc
        - need to make a menu for that tho

CRITICAL TODO LIST BEFORE RELEASE:
    - make the upgraded card packs be in a different color on the backs; have it reflected in the HUD too
        - pink for pack 1, purple for pack 2

    - add an upgrade that prevents one of your cards from being randomly burned when dying

    - check if the player has moved significantly away from the frog, if so, break the frog connection
    - test all this shit in reverse gravity

    - [?] stop all controls if player is in stasis, or has finished a level, or has died
    - make it so you don't waste your spindash cards when pressing spin while already rolling on the ground
    - look through all TODO s. no, seriously, do it ibly.

NEXT UPDATE TODO LIST:
    - add the deck customizer; it's been pushed here because frankly i've ran out of steam for big features like this
]]

local mapobjectscale = mapobjectscale or FRACUNIT -- SRB2 might get this in the future, so we're doing this for in case

function CCards.Check2Run(player, ignoremap)
    if player.bot then return false end
    if not player.khaossp or player.khaossp.ccardsdisable or not player.khaossp.sonicsuite then return false end
    if not CCards.enabled then return false end
    if not ignoremap and mapheaderinfo[gamemap].srb2cecity then return false end
    if (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS) then return false end

    return true
end

local function addCard(tbl)
    -- basic sanity checks
    if not tbl.name then
        assert(nil, "ERROR: Invalid or no name given to effect!")
    end
    if not tbl.graphic and SRB2CE.indev then
        print("WARNING: NO GRAPHIC FOR: " .. tbl.name)
    end

    --[[if not tbl.suite and not tbl.spsave then
        assert(nil, "ERROR: No suite given to card, and no SP save value associated!")
    end]]
    for key, value in pairs(CCardsTable) do
        if tbl.name == value.name then
            assert(nil, "ERROR: Effect name is already taken by something else!")
        end
    end
    table.insert(CCardsTable, tbl)
end

CCards.addCard = addCard

local function indexOfName(array, value) --thanks to amperbee for telling me the obvious that i can just modify this function lol
    for i, v in ipairs(array) do
        if v.name == value then
            return i
        end
    end
    return nil
end

local function indexOfValue(array, value)
    for i, v in ipairs(array) do
        if v == value then
            return v
        end
    end
    return nil
end

local function CalculateCardPileMax(player)
    local number = 10
    if player.khaossp then
        if player.khaossp.deck1 then
        number = $ + 4
        end
        if player.khaossp.deck2 then
            number = $ + 6
        end
    end

    return number
end

local function SpawnSpark(mobj, x, y, z, state)
    local Sperk = P_SpawnMobj(mobj.x + x*2, mobj.y + y*3, mobj.z + z/4, MT_BOXSPARKLE)
    Sperk.scale = mobj.scale
    Sperk.momx = x * 2
    Sperk.momy = y * 2
    Sperk.momz = z * 10
    if state then
        Sperk.state = state
        Sperk.scale = $ / 2
    end
    if (mobj.eflags & MFE_VERTICALFLIP)
        Sperk.momz = -$
        Sperk.eflags = $ | MFE_VERTICALFLIP
        Sperk.flags2 = $ | MF2_OBJECTFLIP
    end
end

local function P_DoChaosJump(player, soundandstate, allowflip, setheight, forcejumpflags) -- lua recreation of P_DoJump, specifically so i can modify it for my own evil purposes.
    local factor
    if setheight == nil then setheight = 39 end
    if allowflip == nil then allowflip = true end
    local dist6 = FixedMul(FixedDiv(player.speed, player.mo.scale), player.actionspd)/20
    local onground = P_IsObjectOnGround(player.mo) -- i'm assuming that's what this does, man C can be confusing for someone who doesn't program in C lol

    if player.pflags & PF_JUMPSTASIS or not player.jumpfactor then
        return
    end

    if player.climbing then
        if player.powers[pw_super] then
            player.mo.momz = 5*FRACUNIT
        elseif (player.mo.eflags & MFE_UNDERWATER) then
            player.mo.momz = 2*FRACUNIT
        else
            player.mo.momz = 15*(FRACUNIT/4)
        end

        player.mo.angle = $ - ANGLE_180 -- Turn around from the wall you were climbing.
        player.drawangle = player.mo.angle

        --[[if (!demoplayback || P_ControlStyle(player) == CS_LMAOGALOG)
            P_SetPlayerAngle(player, player.mo.angle)
        end]]

        player.climbing = 0 -- Stop climbing, duh!
        P_InstaThrust(player.mo, player.mo.angle, FixedMul(6*FRACUNIT, player.mo.scale)) -- Jump off the wall.
    elseif P_InQuicksand(player.mo)
        if (player.mo.ceilingz-player.mo.floorz <= player.mo.height-1) then
            return
        end
        player.mo.momz = $ + (setheight*(FRACUNIT/4))>>1
        if (player.mo.momz >= 6*FRACUNIT) then
            player.mo.momz = 6*FRACUNIT --max momz in quicksand
        elseif (player.mo.momz < 0) -- still descending?
            player.mo.momz = (setheight*(FRACUNIT/4))>>1 -- just default to the jump height.
        end
    elseif not (player.pflags & PF_JUMPED) then -- Jump
        if (player.mo.ceilingz-player.mo.floorz <= player.mo.height-1)
            return
        end

        if (player.powers[pw_carry] == CR_PTERABYTE)
            S_StartSound(player.mo, sfx_s3kd7s)
            player.mo.tracer.cusval = $ + 10 -- attempting to break free
            player.mo.tracer.watertop = P_RandomRange(-player.mo.tracer.cusval, player.mo.tracer.cusval) << (FRACBITS - 1)
            player.mo.tracer.waterbottom = P_RandomRange(-player.mo.tracer.cusval, player.mo.tracer.cusval) << (FRACBITS - 1)
            player.mo.tracer.cvmem = P_RandomRange(-player.mo.tracer.cusval, player.mo.tracer.cusval) << (FRACBITS - 1)
            return
        end

        -- Jump this high.
        if (player.powers[pw_carry] == CR_PLAYER) then
            player.mo.momz = 9*FRACUNIT
            player.powers[pw_carry] = CR_NONE
            player.mo.target = nil
        elseif (player.powers[pw_carry] == CR_GENERIC) then
            player.mo.momz = 9*FRACUNIT
            player.powers[pw_carry] = CR_NONE
            if (not (player.mo.tracer.flags & MF_MISSILE)) -- Missiles remember their owner!
                player.mo.tracer.target = nil
            end
            player.mo.target = nil
        elseif (player.powers[pw_carry] == CR_ROPEHANG) then
            player.mo.momz = 12*FRACUNIT
            player.powers[pw_carry] = CR_NONE
            player.mo.target = nil
        elseif (player.powers[pw_carry] == CR_ROLLOUT) then
            player.mo.momz = 9*FRACUNIT
            if (player.mo.tracer) then
                if (P_MobjFlip(player.mo.tracer)*player.mo.tracer.momz) > 0
                    player.mo.momz = $ + player.mo.tracer.momz
                end
                if not P_IsObjectOnGround(player.mo.tracer)
                    P_SetObjectMomZ(player.mo.tracer, -9*FRACUNIT, true)
                end

                -- goose the mom a little bit to trigger gravity to process for a tic
                if (player.mo.tracer.eflags & MFE_VERTICALFLIP)
                    player.mo.tracer.momz = $ - 1
                else
                    player.mo.tracer.momz = $ + 1
                end
                player.mo.tracer.flags = $ | MF_PUSHABLE
                player.mo.tracer.tracer = nil
            end
            player.powers[pw_carry] = CR_NONE
            player.mo.target = nil
        elseif (player.mo.eflags & MFE_GOOWATER) then
            player.mo.momz = 7*FRACUNIT
            if (player.charability == CA_JUMPBOOST and onground)
                if (player.charflags & SF_MULTIABILITY)
                    player.mo.momz = $ + FixedMul(FRACUNIT/4, dist6)
                else
                    player.mo.momz = $ + FixedMul(FRACUNIT/8, dist6)
                end
            end
        elseif (maptol & TOL_NIGHTS) then
            player.mo.momz = 18*FRACUNIT
        elseif (player.powers[pw_super] and not (player.charflags & SF_NOSUPERJUMPBOOST)) then
            player.mo.momz = 13*FRACUNIT
            -- Add a boost for super characters with float/slowfall and multiability.
            if (player.charability == CA_JUMPBOOST)
                if (player.charflags & SF_MULTIABILITY)
                    player.mo.momz = $ + FixedMul(FRACUNIT/4, dist6)
                else
                    player.mo.momz = $ + FixedMul(FRACUNIT/8, dist6)
                end
            end
        else
            player.mo.momz = setheight*(FRACUNIT/4) -- Default jump momentum.
            if (player.charability == CA_JUMPBOOST and onground)
                if (player.charflags & SF_MULTIABILITY)
                    player.mo.momz = $ + FixedMul(FRACUNIT/4, dist6)
                else
                    player.mo.momz = $ + FixedMul(FRACUNIT/8, dist6)
                end
            end
        end

        -- Reduce player momz by 58.5% when underwater.
        if (player.mo.eflags & MFE_UNDERWATER)
            player.mo.momz = FixedMul(player.mo.momz, FixedDiv(117*FRACUNIT, 200*FRACUNIT))
        end

        --player.pflags = $ | PF_STARTJUMP
        player.ccards.jumpactive = true
    end

    local factor = player.jumpfactor
    if (twodlevel or (player.mo.flags2 & MF2_TWOD)) then
        factor = $ + player.jumpfactor / 10
    end

    if (player.charflags & SF_MULTIABILITY and player.charability == CA_DOUBLEJUMP and (player.actionspd >> FRACBITS) != -1)
        factor = $ - max(0, player.secondjump * player.jumpfactor / ((player.actionspd >> FRACBITS) + 1)) -- Reduce the jump height each time
    end

    --if (maptol & TOL_NIGHTS)
    --	factor = player.jumpfactor -- all skins jump the same. if you nerf jumping abilities, you may want this.

    P_SetObjectMomZ(player.mo, FixedMul(factor, player.mo.momz), false) -- Custom height

    -- set just an eensy above the ground
    if (player.mo.eflags & MFE_VERTICALFLIP) then
        player.mo.z = $ - 1
        if (player.mo.pmomz < 0)
            player.mo.momz = $ + player.mo.pmomz -- Add the platform's momentum to your jump.
        end
        player.mo.pmomz = 0
    else
        player.mo.z = $ + 1
        if (player.mo.pmomz > 0)
            player.mo.momz = $ + player.mo.pmomz -- Add the platform's momentum to your jump.
        end
        player.mo.pmomz = 0
    end

    player.mo.eflags = $ & ~MFE_APPLYPMOMZ

    if forcejumpflags then
        player.pflags = $ | PF_JUMPED
    else
        player.pflags = $ | P_GetJumpFlags(player)
    end

    if (player.charflags & SF_NOJUMPDAMAGE)
        player.pflags = $ & ~PF_SPINNING
    end

    if (allowflip and P_InJumpFlipSector(player.mo)) then -- Flip gravity on jump?
        player.mo.flags2 = $ & MF2_OBJECTFLIP -- what in the flying fuck does ^= mean, it better mean this
        S_StartSound(player.mo, sfx_s3k73) -- Play gravity flip sound
    end

    if (soundandstate) then
        if not (player.spectator) then
            S_StartSound(player.mo, sfx_jump) -- Play jump sound!
        end

        player.mo.state = S_PLAY_JUMP
    end
end

local function P_DoChaosSpinAbility(player, forcespin, button, mindash, maxdash)
    local canstand = true --can we stand on the ground? (mostly relevant for slopes)
    if not mindash then mindash = player.mindash end
    if not maxdash then maxdash = player.maxdash end
    local onground = P_IsObjectOnGround(player.mo)
    if (player.pflags & PF_STASIS
        and (player.pflags & PF_JUMPSTASIS or player.mo.state != S_PLAY_GLIDE_LANDING))
        return
    end

    canstand = (not player.mo.standingslope or (player.mo.standingslope.flags & SL_NOPHYSICS) or abs(player.mo.standingslope.zdelta) < FRACUNIT/2)

    -------------------------------
    -- ability-specific behavior --
    -------------------------------

    if not (player.pflags & PF_SLIDING) and not player.exiting and not P_PlayerInPain(player)
        if player.charability2 == CA2_SPINDASH or forcespin then -- Spinning and Spindashing
            -- Start revving
            if (button) and (player.speed < FixedMul(5<<FRACBITS, player.mo.scale) or player.mo.state == S_PLAY_GLIDE_LANDING)
            and player.mo.momz == 0 and onground and (not (player.pflags & (PF_SPINNING) or player.ccards.spinactive))
            and canstand then
                player.mo.momx = player.cmomx
                player.mo.momy = player.cmomy
                player.pflags = $ | (PF_STARTDASH|PF_SPINNING)
                player.ccards.spinactive = true
                player.dashspeed = mindash
                player.mo.state = S_PLAY_SPINDASH
                if (not player.spectator)
                    S_StartSound(player.mo, sfx_spndsh) -- Make the rev sound!
                end
            -- Revving
            elseif ((button) and (player.pflags & PF_STARTDASH)) then
                if (player.speed >= 5*player.mo.scale)
                    player.pflags = $ & ~PF_STARTDASH
                    player.mo.state = S_PLAY_ROLL
                    S_StartSound(player.mo, sfx_spin)
                end
                if (player.dashspeed < mindash)
                    player.dashspeed = mindash
                end

                if (player.dashspeed > maxdash)
                    player.dashspeed = maxdash
                end

                if (player.dashspeed < maxdash and mindash != maxdash) then
                    local chargecalculation = (6*(player.dashspeed - mindash))/(maxdash - mindash)
                    player.dashspeed = $ + FRACUNIT
                    if (not player.spectator and player.ccards.soundcalculation != chargecalculation)
                        S_StartSound(player.mo, sfx_spndsh) -- Make the rev sound!
                    end
                    player.ccards.soundcalculation = chargecalculation -- this is the best i can do considering the hideous way C handles this. why in the flying fuck is C like this, the more i learn about C the less i want to actually learn it.
                end
                if (player.revitem and  not (leveltime % 5)) then -- Now spawn the color thok circle.
                    --P_SpawnSpinMobj(player, player.revitem)
                    --G_GhostAddRev() -- doesn't exist in lua. if this is needed, then fuck you
                end
            -- If not moving up or down, and travelling faster than a speed of five while not holding
            -- down the spin button and not spinning.
            -- AKA Just go into a spin on the ground, you idiot. )
            elseif ((button or ((twodlevel or (player.mo.flags2 & MF2_TWOD)) and player.cmd.forwardmove < -20))
            and not player.climbing and not player.mo.momz and onground and (player.speed > FixedMul(5<<FRACBITS, player.mo.scale)
            or not canstand) and not (player.pflags & (PF_SPINNING) or player.ccards.spinactive)) then
                player.pflags = $ | (PF_SPINNING)
                player.ccards.spinactive = not $
                player.mo.state = S_PLAY_ROLL
                if (not player.spectator)
                    S_StartSound(player.mo, sfx_spin)
                end
            end
        end
    end

    -------------------------------
    -- general spinning behavior --
    -------------------------------

    -- Rolling normally
    if (onground and player.pflags & PF_SPINNING and not (player.pflags & PF_STARTDASH) and player.speed < 5*player.mo.scale and canstand) then
        if ((player.mo.subsector.sector.specialflags & SSF_FORCESPIN) or (player.mo.ceilingz - player.mo.floorz < P_GetPlayerHeight(player))) then
            P_InstaThrust(player.mo, player.mo.angle, 10*player.mo.scale)
        else
            player.skidtime = 0
            player.pflags = $ & ~PF_SPINNING
            player.mo.state = S_PLAY_STND
            player.mo.momx = player.cmomx
            player.mo.momy = player.cmomy
        end
    end

    if (onground and player.pflags & PF_STARTDASH) then
        -- Spawn spin dash dust
        if (not (player.charflags & SF_NOSPINDASHDUST) and not (player.mo.eflags & MFE_GOOWATER))
            P_DoSpinDashDust(player)
        end
    end
end

local function JumpEnd(player)
    if (player.pflags & PF_JUMPED and player.ccards.jumpactive) and (P_MobjFlip(player.mo)*player.mo.momz > 0) then
        local momz = P_MobjFlip(player.mo)*player.mo.momz --i don't fucking know why reverse gravity always breaks shit, so we'll normalize it first
        player.mo.momz = momz >> 1
        player.mo.momz = P_MobjFlip(player.mo)*$ -- now we add it back. why does it work normally in C but not in lua????????
        player.ccards.jumpactive = false
    end
end

--!! taken from L_ringattraction-v1.lua !! --

--[[
    Classic Ring Attraction script by Golden.
    Modified for CCards by EeveeEuphoria.
    Replicates how rings attract to the player in Sonic 3 and Sonic Mania.

    Lua people:
        To make your object also be effected by this script,
        just hook it into MobjThinker with the function A_ClassicRingAttract like so:

        addHook("MobjThinker", A_ClassicRingAttract, MT_CYBRAKDEMON)
]]

-- A list of objects to hook immediately during load.
local objects = {MT_RING, MT_FLINGRING, MT_COIN, MT_FLINGCOIN}

-- Change an object's type without deleting it.
-- Not globalising because I don't want to cause
-- people to actually use this.
local function changeObjectType(mo, newType)
    mo.type = newType

    local info = mobjinfo[newType]

    -- Set several mobj variables to their new defaults.
    mo.health = info.spawnhealth
    mo.reactiontime = info.reactiontime
    mo.radius = info.radius
    mo.height = info.height
    mo.flags = info.flags
end

-- Apply ring momentum for ring attraction.
-- [12:40 AM] MT_FLAME: ["mom" .. dimension] is extremely crafty
local function doRingMomentum(mo, dimension)
    -- where dimension == "x"
    -- mo[dimension] == mo.x
    -- mo["mom" .. dimension] == mo.momx

    local followmo = mo.followmo

    -- When moving toward player, accelerate fast
    -- When moving away from player, accelerate slow
    -- Always try to go towards player.

    if followmo[dimension] > mo[dimension] then
        if mo["mom" .. dimension] > followmo["mom" .. dimension] then
            mo["mom" .. dimension] = $ + FRACUNIT*2
        else
            mo["mom" .. dimension] = $ + FRACUNIT*4
        end
    elseif followmo[dimension] < mo[dimension] then
        if mo["mom" .. dimension] < followmo["mom" .. dimension] then
            mo["mom" .. dimension] = $ - FRACUNIT*2
        else
            mo["mom" .. dimension] = $ - FRACUNIT*4
        end
    end
end

-- Perform classic ring attraction. And many checks. Soo many checks.
local function CC_ClassicRingAttract(mo)
    -- Don't attract the rancid decomposing dead rings!
    if mo.health == 0 then
        mo.followmo = nil
        return
    end

    -- Check if player exists and is in range, and if so, link them to us.
    -- Otherwise, don't continue.
    if not mo.followmo or not mo.followmo.valid
    or not mo.followmo.player or not mo.followmo.player.valid then
        local target = mo.target -- Get current target, cause P_SupermanLook4Players overwrites it.
        local success = P_SupermanLook4Players(mo, 0, true)
        if success then
            if P_AproxDistance(P_AproxDistance(mo.x-mo.target.x, mo.y-mo.target.y), mo.z-mo.target.z) > RING_DIST
            or ((mo.target.player.powers[pw_shield] & SH_PROTECTELECTRIC) or (mo.target.player.ccards.attract == 0)) -- this is needed because if we don't do this, then rings on moving platforms get messed up
            then
                mo.target = target
                return
            end
            mo.followmo = mo.target
            mo.target = target
        else
            return
        end
    end


    local followmo = mo.followmo

    if followmo.player.ccards.attract > 0 then -- just in case
        mo.attract = true
    end

    -- If the player doesn't have electrical protection, fling off!
    -- ...except this is the opposite now, oh no
    if not (mo.attract) or (followmo.player.powers[pw_shield] & SH_PROTECTELECTRIC) then
        mo.flags = $ & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT & ~MF_NOGRAVITY
        mo.followmo = nil

        if mo.attractive then -- But only if we're too good for them.
            if mo.type == MT_RING then
                changeObjectType(mo, MT_FLINGRING)
                mo.fuse = 8*TICRATE
            end
            mo.attractive = false -- Someone forgot to put on makeup...
        end

        return
    else
        mo.attractive = true -- We're beautiful
    end

    mo.fuse = 0 -- Never disappear

    mo.flags = $ | MF_NOCLIP | MF_NOCLIPHEIGHT | MF_NOGRAVITY -- Go through everything

    -- Do the actual movement
    doRingMomentum(mo, "x")
    doRingMomentum(mo, "y")
    doRingMomentum(mo, "z")

    mo.state = mo.state -- Update state

    P_MoveOrigin(mo, mo.x + mo.momx, mo.y + mo.momy, mo.z + mo.momz) -- Update position using momentum.

    return true -- Skip ring thinker.
end

-- For each object type in objects, hook CC_ClassicRingAttract to their thinker.
-- Yes, this is valid Lua code.
for i, v in ipairs(objects) do
    addHook("MobjThinker", CC_ClassicRingAttract, v)
end

addCard{name = "Temp. Jump", chance = FRACUNIT/5, amount = 5, graphic = "CC_JUMP_TEMP", dontcount = true, noamount = true, nomystery = true, noflip = true, suite = "EXCLAIM",
description = "Oops, you shouldn't be seeing this!",
func = function(player, selfid, value, button)
end
}


addCard{name = "Jump", chance = FRACUNIT/5, amount = 5, grounded = true, maxbuttonval = 2, suite = "SONIC", graphic = "CC_JUMP",
description = "A basic jump.",
foilsave = "jumpfoil", foilprice = 150, foilamount = 5, descriptionfoil = "Gives you +5 cards!",
func = function(player, selfid, value, button)
    P_DoChaosJump(player, true, true, nil, true)
    player.mo.state = S_PLAY_ROLL
    value.amount = $ - 1 -- TODO: move this to end func, but make sure player has actually jumped before subtracting the card
end,
endfunc = function(player, selfid, value, button)
    JumpEnd(player)
end
}

addCard{name = "Frog", chance = FRACUNIT/16, amount = 2, grounded = true, maxbuttonval = 2, graphic = "CC_FROG", spsave = "frogcard", price = 30,
description = "Summons a frog friend you can ride! Just don't get squished by it...",
foilsave = "frogfoil", foilprice = 50, foilamount = 2, descriptionfoil = "Gives you +2 cards, and frogs stick around a bit longer!",
func = function(player, selfid, value, button)
    --TODO: flip the frog if the player is flipped
    local frog = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.floorz, MT_CHAOSFROG)
    local offset = frog.height + (FRACUNIT/5)
    if P_MobjFlip(player.mo) == -1 then
        frog.z = player.mo.ceilingz - frog.height
        frog.eflags = $ | MFE_VERTICALFLIP
        frog.flags2 = $ | MF2_OBJECTFLIP
        offset = -$
    end
    S_StartSound(frog, sfx_chfrog)
    frog.delay = TICRATE
    frog.angle = player.drawangle
    frog.selfdestruct = 15*TICRATE
    if value.foil then
        frog.selfdestruct = 25*TICRATE
    end
    P_MoveOrigin(player.mo, player.mo.x, player.mo.y, player.mo.z + offset)

    value.amount = $ - 1
end}


addCard{name = "Delete", chance = FRACUNIT/20, amount = 2, maxbuttonval = 2, spsave = "deletecard", price = 50, graphic = "CC_DELETE",
descriptiont = {"Deletes things that are in front of you! Be wary of what you delete...", "This also lowers the terrain if you're too close, be wary of that too!"},
foilsave = "deletefoil", foilprice = 50, foilamount = 2, descriptiontfoil = {"Gives you +2 cards, and makes you immune to deleting yourself!"},
func = function(player, selfid, value, button)
    local xmove = P_ReturnThrustX(player.mo, player.mo.angle, FixedMul(136*FRACUNIT, player.mo.scale))
    local ymove = P_ReturnThrustY(player.mo, player.mo.angle, FixedMul(136*FRACUNIT, player.mo.scale))
    local delete = P_SpawnMobjFromMobj(player.mo, xmove, ymove, player.height/2, MT_CHAOSDELETE)
    delete.scale = FRACUNIT*2
    delete.floorsink = player.mo.floorz
    delete.foil = value.foil
    delete.expectedfloor = P_FloorzAtPos(player.mo.x + xmove, player.mo.y + ymove, player.mo.z, 24*2*FRACUNIT)
    if P_MobjFlip(player.mo) < 0 then
        delete.flipma = true
        delete.floorsink = player.mo.ceilingz
        delete.expectedfloor = P_CeilingzAtPos(player.mo.x + xmove, player.mo.y + ymove, player.mo.z, 24*2*FRACUNIT)
    end
    S_StartSound(delete, sfx_chdel1)
    --P_InstaThrust(player.mo, player.mo.angle, (FixedMul(player.dashspeed, player.mo.scale)))


    value.amount = $ - 1
end}

addCard{name = "Ring Sling", chance = FRACUNIT/22, amount = 10, maxbuttonval = 2, spsave = "ringcard", price = 30, graphic = "CC_RINGSLING",
description = "Throw a homing ring at your foes!",
func = function(player, selfid, value, button)
    local ring = P_SpawnPlayerMissile(player.mo, MT_REDRING, 0)
    if ring and ring.valid then -- have to do this because the ring might spawn in a wall/enemy, thus it instantly deletes itself
        ring.chaoshome = true -- thank you ring sling revolution for doing all the hard work for me :)
    end
    value.amount = $ - 1
end}

local FINEANGLES = 8192
local FINEMASK = FINEANGLES - 1
local ANGLETOFINESHIFT = 19

local function FakeRingBurstFire(actor, var1, var2) -- use var2 for amount of time to collect rings, if set to 0 it's 8 seconds, the default amount;
    --[[if var2
        S_StartSound(actor.tracer, sfx_sttb3)
    else
        S_StartSound(actor, sfx_s3kb9)
    end]]

    if not var2 var2 = 3 end

    local i
    local mo
    local fa, va
    local ns
    local z
    local nightsreplace = ((maptol & TOL_NIGHTS) and not G_IsSpecialStage(gamemap))

    -- Better safe than sorry.
    if not actor
        --print("no actor!")
        return
    end

    if (var1 > 32)
        var1 = 32
    end

    if (abs(actor.momx) > actor.scale or abs(actor.momy) > actor.scale)
        va = R_PointToAngle2(actor.momx, actor.momy, 0, 0)>>ANGLETOFINESHIFT
    else
        va = actor.angle>>ANGLETOFINESHIFT
    end

    for i = var1, 1, -1 do
        --print("gamer " .. i)
        local objType = MT_KHAOSFAKERING

        z = actor.z
        if (actor.eflags & MFE_VERTICALFLIP)
            z = $ + (actor.height - mobjinfo[objType].height)
        end

        mo = P_SpawnMobj(actor.x, actor.y, z, objType)
        mo.onfire = true
        if (actor.eflags & MFE_VERTICALFLIP)
            mo.momz = $ * -1
            mo.eflags = $ | MFE_VERTICALFLIP
            mo.flags2 = $ | MF2_OBJECTFLIP
        end

        mo.fuse = var2*TICRATE
        mo.target = actor

        if var3 then
            mo.target = var3
            mo.endspawn = true
        end

        mo.destscale = actor.scale
        mo.scale = actor.scale

        -- Angle offset by player angle, then slightly offset by amount of rings
        --fa = ((i*FINEANGLES/16) + va - ((var1-1)*FINEANGLES/32)) & FINEMASK
        fa = (((i*FINEANGLES/16) + va - ((var1-1)*FINEANGLES/32)) & FINEMASK) * ANG1

        -- Make rings spill out around the player in 16 directions like SA, but spill like Sonic 2.
        -- Technically a non-SA way of spilling rings. They just so happen to be a little similar.
        local momxy
        local momz -- base horizonal/vertical thrusts

        if (i > 15)
            momxy = 3*FRACUNIT
            momz = (4+5)*FRACUNIT
        else
            momxy = 2*FRACUNIT
            momz = (3+6)*FRACUNIT
        end

        if var3 then
            momxy = $ + P_RandomRange(-1, 3)*FRACUNIT + P_RandomFixed()
            momz = $ + P_RandomRange(-1, 2)*FRACUNIT + P_RandomFixed()
            fa = $ + (P_RandomRange(-3, 3) * ANG1)
        end

        ns = FixedMul(FixedMul(momxy, FRACUNIT + FixedDiv((TICRATE/2)<<FRACBITS, 10*TICRATE<<FRACBITS)), mo.scale)
        mo.momx = FixedMul(cos(fa),ns)
        mo.color = SKINCOLOR_FLAME
        if P_RandomChance(FRACUNIT/4) then
            mo.color = SKINCOLOR_KETCHUP
        end
        if P_RandomChance(FRACUNIT/4) then
            mo.color = SKINCOLOR_RED
        end
        if P_RandomChance(FRACUNIT/4) then
            mo.color = SKINCOLOR_CRIMSON
        end

        if (not twodlevel or (actor.flags2 & MF2_TWOD))
            mo.momy = FixedMul(sin(fa),ns)
        end

        ns = FixedMul(momz, FRACUNIT + FixedDiv((TICRATE/2)<<FRACBITS, 10*TICRATE<<FRACBITS))
        P_SetObjectMomZ(mo, ns, false)

        if (i & 1)
            P_SetObjectMomZ(mo, ns, true)
        end
    end


    return
end

addCard{name = "Lava Boost", chance = FRACUNIT/7, amount = 3, grounded = true, suite = "FANG", alwaysrunfunc = true, graphic = "CC_LAVABOOST", resetonrespawn = true,
description = "You get sent up high! ...but you also burn a few of your rings!",
func = function(player, selfid, value, button)
    --TODO: allow holding the button to charge up the jump to be stronger
    if button == 1 and not value.started then
        player.pflags = $ | PF_SPINNING
        player.mo.z = $ + (P_MobjFlip(player.mo) * 5) -- give a little nudge up
        player.mo.momz = $ + (P_MobjFlip(player.mo) * (15*FRACUNIT))
        S_StartSound(player.mo, sfx_s1ae)
        if player.rings > 0 then
            if (mapheaderinfo[gamemap].bonustype == 1 or mapheaderinfo[gamemap].bonustype == 2) then --less rings taken on boss fights
                if player.rings > 1 then -- don't take the last ring, that'd be cruel
                    S_StartSound(player.mo, sfx_antiri)
                    player.rings = $ - 1
                    FakeRingBurstFire(player.mo, 1, nil)
                end
            else
                S_StartSound(player.mo, sfx_antiri)
                -- i swear there's an easier way to do this, but i suck at math so this is what happens
                local counter = 0
                repeat
                    counter = $ + 1
                    player.rings = $ - 1
                until counter == 3 or player.rings == 0
                FakeRingBurstFire(player.mo, counter, nil)
            end
        end
        player.mo.state = S_PLAY_STUN
        player.powers[pw_flashing] = TICRATE*1
        value.amount = $ - 1
        value.started = true
    end
    if value.started then
        SpawnSpark(player.mo, P_RandomFixed(), P_RandomFixed(), P_RandomFixed(), S_SPINDUST_FIRE1)
        if P_IsObjectOnGround(player.mo) then
           value.started = false
        end
    end
end}

addCard{name = "Wheel", chance = FRACUNIT/15, amount = 4, grounded = true, suite = "FANG", alwaysrunfunc = true, resetonrespawn = true, graphic = "CC_WHEEL",
descriptiont = {"Turn yourself into a rolling machine of death!", "You can also bonk against a wall for significant height!"},
foilsave = "wheelfoil", foilprice = 50, foilamount = 2, descriptiontfoil = {"Gives you +2 cards, and you have a slightly higher max speed!"},

func = function(player, selfid, value, button)

    if value.started then
        value.thrust = min($ + (2*player.mo.scale + player.mo.scale/2), value.maxthrust)

        if not player.powers[pw_invulnerability] then
            player.powers[pw_invulnerability] = 2
        end
        P_InstaThrust(player.mo, player.mo.angle, value.thrust)
        if player.mo.state != S_PLAY_ROLL then
            player.mo.state = S_PLAY_ROLL
            player.pflags = $ | PF_SPINNING
        end

        if (value.timer % 62) == 0 then
            S_StartSound(player.mo, sfx_chwhl)
        end

        value.timer = $ + 1

        if player.khaos.wallblock == TICRATE-1 or button == 2 then
            if player.khaos.wallblock == TICRATE-1 then
                local numangles = 6
                local limitangle = (360/numangles)
                local travelangle = player.mo.angle + P_RandomRange(-limitangle, limitangle)*ANG1
                for i=0, numangles, 1 do
                    local spark = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THUNDERCOIN_SPARK)
                    if spark and spark.valid then
                        P_InstaThrust(spark, travelangle + i*(4294967294/numangles), FixedMul(4*FRACUNIT, spark.scale))
                        if (i % 2) == 0 then
                            P_SetObjectMomZ(spark, -4*FRACUNIT, false)
                        end
                        spark.fuse = 18
                    end
                end
                P_SetObjectMomZ(player.mo, 15*FRACUNIT, false)
                S_StartSound(player.mo, sfx_chwhl2)
            end
            if S_SoundPlaying(player.mo, sfx_chwhl) then
                S_StopSoundByID(player.mo, sfx_chwhl)
            end
            player.mo.state = S_PLAY_FALL
            player.pflags = $ & ~PF_SPINNING
            value.started = false
            value.amount = $ - 1
            value.buffer = true
        end
    end

    if not button and value.buffer then
        value.buffer = false
    end


    if not value.started and button == 2 and not value.buffer then
        value.started = true
        value.thrust = player.speed
        value.maxthrust = 55*player.mo.scale
        if value.foil then
           value.maxthrust = $ + FRACUNIT*10
        end
        value.timer = 62
    end
end}

addCard{name = "Spindash", chance = FRACUNIT/8, amount = 3, grounded = true, suite = "SONIC", graphic = "CC_SPIN",
description = "A basic spindash.",
func = function(player, selfid, value, button)
    if player.mo.state ~= S_PLAY_ROLL and player.mo.state ~= S_PLAY_PAIN then
        if value.mystery then
            value.mystery = false
        end
        P_DoChaosSpinAbility(player, true, button, 15*FRACUNIT, 70*FRACUNIT)
    else
        value.used = true
    end
end,
endfunc = function(player, selfid, value, button)
    if (P_IsObjectOnGround(player.mo) and (player.pflags & PF_STARTDASH) and (player.pflags & PF_SPINNING)) then
        player.pflags = $ & ~PF_STARTDASH
        if (player.powers[pw_carry] == CR_BRAKGOOP)
            player.dashspeed = 0
        end

        if (not ((gametyperules & GTR_RACE) and leveltime < 4*TICRATE)) then
            if (player.dashspeed) then
                player.mo.state = S_PLAY_ROLL
                P_InstaThrust(player.mo, player.mo.angle, (FixedMul(player.dashspeed, player.mo.scale))) -- catapult forward ho!!
                player.speed = FixedMul(player.dashspeed, player.mo.scale)
            else
                player.mo.state = S_PLAY_STND
                player.pflags = $ & ~PF_SPINNING
            end
            if (not player.spectator)
                S_StartSound(player.mo, sfx_zoom)
            end
        end
        value.amount = $ - 1
    elseif player.pflags & PF_SPINNING then
        value.amount = $ - 1
    end
    player.dashspeed = 0
end}


addCard{name = "S. Spindash", chance = FRACUNIT/15, amount = 3, grounded = true, suite = "AMY", graphic = "CC_SUPERSPIN",
description = "Super charged Spindash that costs rings to use.", description2 = "It'll also drain rings while you hold it!",
func = function(player, selfid, value, button)
    if player.mo.state ~= S_PLAY_ROLL and player.mo.state ~= S_PLAY_PAIN then
        local mindash, maxdash = 35*FRACUNIT, 130*FRACUNIT
        if player.rings > 0 then
            if (leveltime % (TICRATE/2)) == 0 then
                S_StartSound(player.mo, sfx_antiri)
                P_GivePlayerRings(player, -1)
            end
        else
            mindash, maxdash = 15*FRACUNIT, 70*FRACUNIT
        end
        if value.mystery then
            value.mystery = false
        end
        P_DoChaosSpinAbility(player, true, button, mindash, maxdash)
    else
        value.used = true
    end
end,
endfunc = function(player, selfid, value, button)
    if (P_IsObjectOnGround(player.mo) and (player.pflags & PF_STARTDASH) and (player.pflags & PF_SPINNING)) then
        player.pflags = $ & ~PF_STARTDASH
        if (player.powers[pw_carry] == CR_BRAKGOOP)
            player.dashspeed = 0
        end

        if (not ((gametyperules & GTR_RACE) and leveltime < 4*TICRATE)) then
            if (player.dashspeed) then
                player.mo.state = S_PLAY_ROLL
                P_InstaThrust(player.mo, player.mo.angle, (FixedMul(player.dashspeed, player.mo.scale))) -- catapult forward ho!!
                player.speed = FixedMul(player.dashspeed, player.mo.scale)
            else
                player.mo.state = S_PLAY_STND
                player.pflags = $ & ~PF_SPINNING
            end
            if (not player.spectator)
                S_StartSound(player.mo, sfx_zoom)
            end
        end
        value.amount = $ - 1
    elseif player.pflags & PF_SPINNING then
        value.amount = $ - 1
    end
    player.dashspeed = 0
end}

addCard{name = "High Jump", chance = FRACUNIT/18, amount = 4, grounded = true, maxbuttonval = 2, graphic = "CC_HIJUMP", suite = "AMY",
description = "Jump that sends you pretty high!",
func = function(player, selfid, value, button)
    P_DoChaosJump(player, true, true, 79, true)
    player.mo.state = S_PLAY_ROLL
    value.amount = $ - 1
end,
endfunc = function(player, selfid, value, button)
    JumpEnd(player)
end}

addCard{name = "Red Button", chance = FRACUNIT/10, amount = 1, maxbuttonval = 2, dontdraw = true, removemewhenfinished = true, graphic = "CC_BLOWSUP", nomystery = true,
description = "This is it, you've drawn your last card. If all hope is lost, then go out the best way you can.",
func = function(player, selfid, value, button)
    value.amount = $ - 1
    local radius = 3096
    if netgame then
        radius = 256
    else
        local explosiontime = 128
        repeat
            local x = P_RandomRange(-radius/2, radius/2)*FRACUNIT
            local y = P_RandomRange(-radius/2, radius/2)*FRACUNIT
            local z = P_FloorzAtPos(player.mo.x + x, player.mo.y + y, player.mo.floorz, 24*FRACUNIT)
            local Explode = P_SpawnMobjFromMobj(player.mo, x, y, 0, MT_BOSSEXPLODE)
            Explode.z = z
            Explode.destscale = P_RandomRange(3, 12)*player.mo.scale
            Explode.scalespeed = player.mo.scale/4
            if P_RandomChance(FRACUNIT/2) then
               Explode.tics = $ + 2
            end
            explosiontime = $ - 1
        until explosiontime <= 0
    end
    local Explode = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_BOSSEXPLODE)
    Explode.destscale = 6*player.mo.scale
    Explode.scalespeed = player.mo.scale/6

    P_RadiusAttack(player.mo, player.mo, radius*FRACUNIT, nil, false)
    S_StartSound(Explode, sfx_bkpoof)
    P_StartQuake(75*FRACUNIT, 1*TICRATE)
    player.rings = 0
    P_KillMobj(player.mo)
    player.starpostnum = 0

    local a, x, y, z --= player.ccards.spawna, player.ccards.spawnx/FRACUNIT, player.ccards.spawny/FRACUNIT, player.ccards.spawnz/FRACUNIT
    for mapthing in mapthings.iterate do
        if mapthing.valid and mapthing.type == 1 then
            a, x, y, z = mapthing.angle*ANG1, mapthing.x, mapthing.y, mapthing.z
        end
    end

    player.starpostangle, player.starpostx, player.starposty, player.starpostz = a, x, y, z

    --if not player.khaossp.deck3 then
        player.ccards.cardpile = player.ccards.cardpileMax + 3
    --else
        --player.ccards.cardpile = player.ccards.cardpileMax
    --end
    player.ccards.RedButton = true
    player.ccards.memory = {}
    player.ccards.SlotJT.amount = 0
    player.ccards.SlotST.amount = 0
    player.ccards.SlotCT.amount = 0
end}

addCard{name = "Explosion", chance = FRACUNIT/10, amount = 3, maxbuttonval = 2, graphic = "CC_EXPLODE", suite = "FANG",
description = "This will catapult you in a set arc! ...by means of explosion.",
func = function(player, selfid, value, button)
    if player.mo.state != S_PLAY_PAIN then
        value.amount = $ - 1
        player.mo.z = $ + (P_MobjFlip(player.mo) * 5) -- give a little nudge up
        player.mo.momz = $ + (P_MobjFlip(player.mo) * (15*FRACUNIT))
        P_InstaThrust(player.mo, player.mo.angle, 75*FRACUNIT)
        player.mo.state = S_PLAY_PAIN
        player.powers[pw_flashing] = TICRATE*1

        local Explode = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_BOSSEXPLODE)
        P_RadiusAttack(player.mo, player.mo, 512*FRACUNIT, nil, false)
        S_StartSound(Explode, sfx_bkpoof)
        Explode.destscale = 4*player.mo.scale
        Explode.scalespeed = player.mo.scale/6
    end
end}

addCard{name = "Spark Jump", chance = FRACUNIT/13, amount = 4, maxbuttonval = 2, graphic = "CC_SPARKJ", suite = "AMY",
description = "A smaller jump, but it attracts all rings around you, and can be used mid-air.",
foilsave = "sjumpfoil", foilprice = 150, foilamount = 4, descriptionfoil = "Gives you +4 cards, and makes your jump much higher!",
func = function(player, selfid, value, button)
    player.mo.momz = $ + P_MobjFlip(player.mo)*(11*FRACUNIT)
    player.pflags = $ | (PF_JUMPED)
    player.mo.state = S_PLAY_ROLL
    value.amount = $ - 1

    player.ccards.attract = 5

    local numangles = 6
    if value.spark then
        player.mo.momz = $ + P_MobjFlip(player.mo)*(15*FRACUNIT)
        numangles = 9
    end
    local limitangle = (360/numangles)
    local travelangle = player.mo.angle + P_RandomRange(-limitangle, limitangle)*ANG1
    for i=0, numangles, 1 do
        local spark = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THUNDERCOIN_SPARK)
        if spark and spark.valid then
            P_InstaThrust(spark, travelangle + i*(4294967294/numangles), FixedMul(4*FRACUNIT, spark.scale))
            if (i % 2) == 0 then
                P_SetObjectMomZ(spark, -4*FRACUNIT, false)
            end
            spark.fuse = 18
        end
    end
    S_StartSound(player.mo, sfx_s3k45)
end}

addCard{name = "Thok", chance = FRACUNIT/8, amount = 4, maxbuttonval = 2, graphic = "CC_THOK", suite = "SONIC",
description = "Sonic's Thok! Will slightly propel you up if you're on the ground.",
func = function(player, selfid, value, button)
    if (not (player.pflags & PF_THOKKED) or (player.charflags & SF_MULTIABILITY)) then
        if P_IsObjectOnGround(player.mo) then
            player.mo.z = $ + (P_MobjFlip(player.mo) * 5) -- give a little nudge up
            player.mo.momz = $ + (P_MobjFlip(player.mo) * (5*FRACUNIT))
        end
        player.pflags = $ | P_GetJumpFlags(player)
        player.mo.state = S_PLAY_JUMP
        -- Catapult the player
        local actionspd = 60*FRACUNIT

        if (player.charflags & SF_DASHMODE) then
            actionspd = max(player.actionspd, FixedDiv(player.speed, player.mo.scale))
        end

        if (player.mo.eflags & MFE_UNDERWATER) then
            actionspd = $ >> 1
        end

        P_InstaThrust(player.mo, player.mo.angle, FixedMul(actionspd, player.mo.scale))

        if (maptol & TOL_2D) then
            player.mo.momx = $ / 2
            player.mo.momy = $ / 2
        end

        player.drawangle = player.mo.angle

        if (player.mo.info.attacksound and not player.spectator) then
            S_StartSound(player.mo, player.mo.info.attacksound) -- Play the THOK sound
        end

        P_SpawnThokMobj(player)

        player.pflags = $ & ~(PF_SPINNING|PF_STARTDASH)
        player.pflags = $ | PF_THOKKED

        value.amount = $ - 1
    end
end}

addCard{name = "Spring", chance = FRACUNIT/10, amount = 3, maxbuttonval = 2, grounded = true, suite = "SONIC", graphic = "CC_SPRING",
description = "Bouncepad! This gives you the properties", description2 = "of jumping off a yellow/red/blue spring.",
foilsave = "springfoil", foilprice = 25, foilamount = 1, descriptionfoil = "Gives you an extra card, and increases the odds", description2foil = "of getting a higher-powered spring!",
func = function(player, selfid, value, button)
    local springer = MT_BLUESPRING
    local RANDY = FRACUNIT/2
    if value.foil then
        RANDY = FRACUNIT/2 + FRACUNIT/3
    end
    if P_RandomChance(RANDY) then
        springer = MT_YELLOWSPRING
        if P_RandomChance(RANDY) then
            springer = MT_REDSPRING
        end
    end
    local thespring = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, springer)
    if P_MobjFlip(player.mo) == -1 then
        thespring.z = player.mo.ceilingz - thespring.height
        thespring.eflags = $ | MFE_VERTICALFLIP
        thespring.flags2 = $ | MF2_OBJECTFLIP
    end
    P_DoSpring(thespring, player.mo)
    P_KillMobj(thespring)
    S_StartSound(player.mo, sfx_spring)
    value.amount = $ - 1
end}


addCard{name = "Boost", chance = FRACUNIT/12, amount = 3, suite = "FANG", alwaysrunfunc = true, resetonrespawn = true, graphic = "CC_BOOST",
description = "Gives you a boost similar to Sonic Rush/Sonic Unleashed Wii!",
foilsave = "boostfoil", foilprice = 25, foilamount = 2, descriptionfoil = "Gives you +2 cards, extends the duration of the boost a bit, and attracts rings!",
func = function(player, selfid, value, button)
    if not value.timer then
        value.timer = 0
    end

    --LAMINATION TODO: let you walk on water, and destroy spikes

    if button == 1 then
        if not value.started then
            value.timer = TICRATE*2
            if value.foil then
                value.timer = $ + (TICRATE/2)
            end
            value.started = true
            if value.mystery then
                value.mystery = false
            end
            S_StartSound(player.mo, sfx_chbost)
        else
            value.timer = 1 -- cancel the boost early
        end
    end

    if value.started then
        local thrust = FRACUNIT*8
        if not P_IsObjectOnGround(player.mo) then
            thrust = (FRACUNIT*2) - (FRACUNIT/2)
        end
        if value.foil then
           thrust = $ + FRACUNIT
           player.ccards.attract = 5
        end
        if not player.powers[pw_invulnerability] then
            player.powers[pw_invulnerability] = 2
        end
        P_Thrust(player.mo, player.drawangle, thrust)
        P_SpawnThokMobj(player)
        value.timer = $ - 1
        if value.timer <= 0 or P_PlayerInPain(player) then
            value.amount = $ - 1
            value.started = false
        end
    end
end}

addCard{name = "Hover", chance = FRACUNIT/20, amount = 5, nomultiple = true, graphic = "CC_HOVER", spsave = "hovercard", alwaysrunfunc = true, resetonrespawn = true,
descriptiont = {"Grants you the Hover ability that Metal Sonic has!", "See if you can annoy Metal Sonic into giving you this..."},
foilsave = "hoverfoil", foilprice = 150, foilamount = 3, descriptiontfoil = {"Gives you +3 cards, extending your timer by that much!"},
func = function(player, selfid, value, button)
    -- i don't fucking know where in the source code the ability to hover is, i've seriously looked everywhere. STJR hid it from me on purpose, it's a conspiracy i tell you
    if button > 1 and not P_IsObjectOnGround(player.mo) then
        if not value.started then
            value.timer = value.amount*TICRATE
            value.started = true
        end
        value.timer = $ - 1

        if player.speed > FRACUNIT*6 then
            player.mo.momz = 0
        else
            player.mo.momz = $ / 8
        end

        value.amount = (value.timer/TICRATE)+1
    end
end}

--TODO: allow this to break floors; i.e. the ones fang and amy can break
    -- very important to allow this, for levels that need it (Deep Sea 2)
addCard{name = "Bounce", chance = FRACUNIT/19, amount = 5, alwaysrunfunc = true, graphic = "CC_BOUNCE", suite = "AMY", resetonrespawn = true,
description = "Smash in to the ground, and bounce back up!",
foilsave = "bouncefoil", foilprice = 100, foilamount = 3, descriptionfoil = "Gives you +3 cards, and makes your bounce a bit higher!",
func = function(player, selfid, value, button)
    if value.started then
        P_SpawnThokMobj(player)
        if P_IsObjectOnGround(player.mo) then
            player.mo.z = $ + (P_MobjFlip(player.mo) * 5) -- give a little nudge up
            player.mo.momz = -value.LastMomZ/4
            player.pflags = $ | P_GetJumpFlags(player)
            player.mo.state = S_PLAY_JUMP
            S_StartSound(player.mo, sfx_s3k5f)
            P_StartQuake(10*FRACUNIT, 7, {player.mo.x, player.mo.y, player.mo.z}, 700*FRACUNIT)
            local attackrad = 256
            if value.foil then
                attackrad = 512
            end
            P_RadiusAttack(player.mo, player.mo, attackrad*FRACUNIT, nil, false)
            value.bouncestate = false
            value.started = false
            value.amount = $ - 1

            local numangles = 6
            local limitangle = (360/numangles)
            local travelangle = player.mo.angle + P_RandomRange(-limitangle, limitangle)*ANG1
            for i=0, numangles, 1 do
                local spark = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THUNDERCOIN_SPARK)
                if spark and spark.valid then
                    P_InstaThrust(spark, travelangle + i*(4294967294/numangles), FixedMul(4*FRACUNIT, spark.scale))
                    if (i % 2) == 0 then
                        P_SetObjectMomZ(spark, -4*FRACUNIT, false)
                    end
                    spark.fuse = 18
                end
            end
        else
            value.LastMomZ = player.mo.momz
        end
    end

    if button == 1 and not value.started and not value.bouncestate then
        S_StartSound(player.mo, sfx_s3k51, player)
        local force = 60
        if value.foil then
            force = 75
        end
        player.mo.momz = $ - (P_MobjFlip(player.mo) * force*FRACUNIT)
        value.started = true
        value.bouncestate = true
        player.pflags = $ | P_GetJumpFlags(player)
        player.mo.state = S_PLAY_JUMP
        value.LastMomZ = player.mo.momz
        if value.mystery then
            value.mystery = false
        end
    end
end}

addCard{name = "Thwomp", chance = FRACUNIT/72, amount = 1, alwaysrunfunc = true, graphic = "CC_THWOMP", suite = "CHAOS", troll = true,
description = "This card sends you hurtling towards the ground!", description2= "...if you're already on the ground, it's patient, it'll wait.",
func = function(player, selfid, value, button)
    if value.flip == 0 and value.leaving == 0 and value.flipside == 1 then
        value.timer = $ and $ + 1 or 1
        if value.timer > 5 then
            if not P_IsObjectOnGround(player.mo) and not value.falling and (player.mo.momz*P_MobjFlip(player.mo)) < 0 then
                S_StartSound(player.mo, sfx_s3k51, player)
                if value.mystery then
                    value.mystery = false
                end
                player.mo.momz = $ - (P_MobjFlip(player.mo) * 60*FRACUNIT)
                value.falling = true
            end
            if value.falling and P_IsObjectOnGround(player.mo) then
                S_StartSound(player.mo, sfx_s3k5f)
                P_StartQuake(15*FRACUNIT, 15, {player.mo.x, player.mo.y, player.mo.z}, 1028*FRACUNIT)
                value.amount = $ - 1
                value.timer = 0 -- reset in case there's multiple >:)
                value.falling = false
            end

            if (player.mo.momz*P_MobjFlip(player.mo)) > 0 then -- do it all over again, the player started ascending again! ... could be done differently, but this is the method i'm doing
                value.falling = false
            end
        end
    end

end}

addCard{name = "Anglerfish", chance = FRACUNIT/69, amount = 1, alwaysrunfunc = true, nomultiple = true, graphic = "CC_ANGLERFISH", nomystery = true, suite = "CHAOS", troll = true,
description = "The Nefarious Anglerfish will alert all your enemies of your existence.",
func = function(player, selfid, value, button)
--TODO: in match mode, highlight the position of this player to everyone else. use that one multiplayer co-op player location mod to do it, assuming it's open assets.
    if value.flip == 0 and value.leaving == 0 and value.flipside == 1 then
        value.timer = $ and $ + 1 or 1
        if value.timer > 5 then
            S_StartSound(player.mo, sfx_alarm)
            for mobj in mobjs.iterate() do
                if (mobj.flags & MF_ENEMY) then
                    mobj.target = player.mo
                    --A_Chase(mobj)
                end
            end
            SRB2CE.addHUDText(player, "All enemies have been alerted to your presence!", true)
            player.ccards.nefarious = TICRATE*15
            value.amount = $ - 1
        end
    end
end}

addCard{name = "Brawl Code", chance = FRACUNIT/60, amount = 1, alwaysrunfunc = true, nomultiple = true, graphic = "CC_BRAWL", nomystery = true, suite = "CHAOS", noflip = true, troll = true,
description = "Get tripped up by intentional game design.",
func = function(player, selfid, value, button)
    if value.flip == 0 and value.leaving == 0 and value.flipside == 1 then
        value.timer = $ and $ + 1 or 1
        if value.timer > 5 and P_IsObjectOnGround(player.mo) then
            S_StartSound(player.mo, sfx_chslip)
            player.mo.z = $ + (P_MobjFlip(player.mo) * 5) -- give a little nudge up
            player.mo.momz = (P_MobjFlip(player.mo) * (5*FRACUNIT))
            player.mo.state = S_PLAY_STUN
            value.amount = $ - 1
        end
    end
end}

addCard{name = "Whoosh", chance = FRACUNIT/60, amount = 1, nomultiple = true, graphic = "CC_WHOOSH", spsave = "whooshcard", alwaysrunfunc = true, price = 15, resetonrespawn = true, -- reset is only done if you're a goober and you try to use this right when the level ends
description = "All your cards will be swapped when you use this!",
func = function(player, selfid, value, button)
    if button >= 1 and not value.started then
        player.ccards.cardpile = $ + 3
        value.started = true
    end
    if value.started then
        if value.flip == 0 and value.leaving == 0 and value.flipside == 1 then
            value.timer = $ and $ + 1 or 1
            if value.timer == 5 then
                player.ccards.SlotCT.amount = 0
                value.amount = 1
            end
            if value.timer == 7 then
                player.ccards.SlotST.amount = 0
                value.amount = 1
            end
            if value.timer == 9 then
                player.ccards.SlotJT.amount = 0
                value.amount = 1
            end
            if value.timer == 11 then
                value.amount = 0
            end
        end
    end
end}

addCard{name = "Empty", chance = FRACUNIT/50, amount = 1, dontdraw = true, dontcount = true, nographic = true, noamount = true, nomystery = true, noflip = true, removemewhenfinished = true, alwaysrunfunc = true,
description = "Oops, you shouldn't be seeing this! Ignore me please! Or don't!",
func = function(player, selfid, value, button)
    if player.ccards.cardpile > 0 then -- we suddenly got more cards!
       value.amount = 0
    end
end}

addCard{name = "Wasted Slot", chance = FRACUNIT/50, amount = 5, alwaysrunfunc = true, nomultiple = true, graphic = "CC_WASTED", nomystery = true, suite = "CHAOS", noflip = true, troll = true,
description = "The card slot this is in will serve no purpose for 5 seconds!",
func = function(player, selfid, value, button)
    if value.flip == 0 and value.leaving == 0 and value.flipside == 1 then
        value.timer = $ and $ + 1 or 1
        if value.timer == 5 then
            S_StartSound(player.mo, sfx_chwast)
        end
        if (value.timer % TICRATE) == 0 then
            value.amount = $ - 1
        end
        if value.amount <= 0 then
            S_StartSound(player.mo, sfx_chwasd)
        end
    end
end}

addCard{name = "Purple Gem", chance = FRACUNIT/20, amount = 5, alwaysrunfunc = true, suite = "SONIC", graphic = "CC_PGEM", --resetonrespawn = true,
description = "Gives you the Purple Gem from Sonic '06! Card count acts as a timer.",
foilsave = "pgemfoil", foilprice = 80, foilamount = 3, descriptionfoil = "Gives you +3 cards, extending your timer by that much!",
func = function(player, selfid, value, button)
    --TODO: add purple glow effect when you start using it, and make a little sound when it's activate and deactivated
    if value.started then
        if button == 1 then
            player.mo.momz = P_MobjFlip(player.mo)*(39*(player.mo.scale/4))
            if value.foil then
               player.mo.momz = P_MobjFlip(player.mo)*(50*(player.mo.scale/4))
            end
            player.pflags = $ | P_GetJumpFlags(player)
            player.mo.state = S_PLAY_JUMP
            S_StartSound(player.mo, sfx_jump)
        end

        value.timer = $ - 1

        if value.timer < 2 or player.playerstate == PST_DEAD then
            player.mo.scale = mapobjectscale --value.prevscale
            player.ccards.usingpurplegem = false
        end

        value.amount = (value.timer/TICRATE)+1
        if value.timer == 0 then
            value.amount = 0
        end
    end

    if button > 1 and not value.started and not player.ccards.usingpurplegem then
        value.prevscale = player.mo.scale
        player.mo.scale = mapobjectscale/2
        value.timer = value.amount*TICRATE
        value.started = true
        player.ccards.usingpurplegem = true
        if value.mystery then
            value.mystery = false
        end
    end
end}

addCard{name = "Firework", chance = FRACUNIT/26, amount = 1, alwaysrunfunc = true, suite = "CHAOS", graphic = "CC_FWORK", chaosunlock = "Firework",
description = "Shoots you really far into the sky!", description2= "There's a chance the fireworks will be explosive.",
foilsave = "fworkfoil", foilprice = 75, foilamount = 1, descriptionfoil = "Gives you an additional card, and significantly", description2foil = "reduces the chance to blow up!",
func = function(player, selfid, value, button)
    if button > 1 and not value.started then
        value.timer = TICRATE
        value.started = true
        if value.mystery then
            value.mystery = false
        end
        value.explosive = false
        local amnt = FRACUNIT/2-FRACUNIT/5
        if SRB2CE.AmplifyChecker(player) then
            amnt = FRACUNIT/2+FRACUNIT/3
        end
        if value.foil then
            amnt = $ - FRACUNIT/6 -- this'd make the amplify chance 66.6%. >:3
        end
        if P_RandomChance(amnt) then
            value.explosive = true
        end
        S_StartSound(player.mo, sfx_chadet)
    end

    if value.started then
        local additioner = FRACUNIT + (FRACUNIT/2) + (FRACUNIT/4)
        value.timer = $ - 1

        --[[if (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS) then
            additioner = $ * 20
        end]]

        if player.playerstate == PST_LIVE then
            if (player.mo.eflags & MFE_VERTICALFLIP) or (player.mo.flags2 & MF2_OBJECTFLIP) then
                player.mo.momz = $ - additioner
            else
                player.mo.momz = $ + additioner
            end
        end

        for i=6,1,-1 do
            SpawnSpark(player.mo, P_RandomFixed(), P_RandomFixed(), P_RandomFixed())
            if value.explosive then
                SpawnSpark(player.mo, P_RandomFixed(), P_RandomFixed(), P_RandomFixed(), S_SPINDUST_FIRE1)
            end
        end

        if value.timer <= 0 then
            for i=69,1,-1 do -- nice
                SpawnSpark(player.mo, P_RandomFixed()*4, P_RandomFixed()*5, P_RandomFixed()*6)
            end

            if value.explosive then
                local explode = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_TNTBARREL)
                explode.state = S_TNTBARREL_EXPL1
            end

            value.amount = $ - 1
            value.timer = nil
            value.started = nil
        end
    end
end}

addCard{name = "Wings", chance = FRACUNIT/20, amount = 1, alwaysrunfunc = true, suite = "AMY", resetonrespawn = true, graphic = "CC_WINGS",
--TODO: make foiled version, which gives you an extra card, and extra 3 flaps of flight
description = "You have the ability of flight! After you're", description2 = "done ascending, you can slowly glide back down.",
func = function(player, selfid, value, button)
    if value.started then
        if (button == 1 or ((button % (TICRATE/3)) == 0 and button ~= 0)) and value.winguses < 10 then
            if value.winguses < 10 then
                player.mo.momz = ((P_MobjFlip(player.mo)*11)*FRACUNIT) -- reset momentum entirely instead of adding
                S_StartSound(nil, sfx_chcdw2)
                value.winguses = $ + 1
            end
        end

       if value.winguses >= 10 then
            if button >= 1 then
                if value.wing1 and value.wing1.valid then
                    value.wing1.state = S_CCWINGSFR
                end
                if value.wing2 and value.wing2.valid then
                    value.wing2.state = S_CCWINGSFRF
                end
                if (player.mo.eflags & MFE_VERTICALFLIP) or (player.mo.flags2 & MF2_OBJECTFLIP) then
                    if player.mo.momz > 0 then
                        player.mo.momz = $ - $ / 25
                    end
                else
                    if player.mo.momz < 0 then
                        player.mo.momz = $ - $ / 25
                    end
                end
            else
                if value.wing1 and value.wing1.valid then
                    value.wing1.state = S_CCWINGS
                end
                if value.wing2 and value.wing2.valid then
                    value.wing2.state = S_CCWINGSF
                end
            end
        end

        if P_IsObjectOnGround(player.mo) then
            value.amount = $ - 1
            value.started = false -- we might have more than one use left!
            if value.amount <= 0 then
                -- disengage; delete the wings! make it poof too, have some fancy sparkles or something pop out of each wing
                -- BUT ONLY DO IT IF WINGS EXIST! CHECK FOR VALIDITY FIRST!
                S_StartSound(nil, sfx_chcdwg)
                if value.wing1 and value.wing1.valid then
                    for i=8,1,-1 do
                        SpawnSpark(value.wing1, P_RandomFixed(), P_RandomFixed(), P_RandomFixed())
                    end
                    P_RemoveMobj(value.wing1)
                end
                if value.wing2 and value.wing2.valid then
                    for i=8,1,-1 do
                        SpawnSpark(value.wing2, P_RandomFixed(), P_RandomFixed(), P_RandomFixed())
                    end
                    P_RemoveMobj(value.wing2)
                end
            end
        end
    else
       if button >= 1 then
            if P_IsObjectOnGround(player.mo) then
                player.mo.z = $ + (P_MobjFlip(player.mo) * 5) -- give a little nudge up
                player.mo.momz = $ + ((P_MobjFlip(player.mo)*11)*FRACUNIT)
            end
            player.pflags = $ | P_GetJumpFlags(player)
            player.mo.state = S_PLAY_JUMP
            if value.mystery then
                value.mystery = false
            end

            if not value.wing1 or not value.wing1.valid then
                value.wing1 = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_CCWINGS)
                value.wing1.wing = 1 -- right wing
                value.wing1.target = player.mo
                value.wing2 = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_CCWINGS)
                value.wing2.wing = 2 -- left wing
                value.wing2.state = S_CCWINGSF
                value.wing2.target = player.mo
                if P_MobjFlip(player.mo) == -1 then
                    value.wing1.eflags = $ | MFE_VERTICALFLIP
                    value.wing1.flags2 = $ | MF2_OBJECTFLIP
                    value.wing2.eflags = $ | MFE_VERTICALFLIP
                    value.wing2.flags2 = $ | MF2_OBJECTFLIP
                end

                for i=8,1,-1 do
                    SpawnSpark(value.wing1, P_RandomFixed(), P_RandomFixed(), P_RandomFixed())
                end
                for i=8,1,-1 do
                    SpawnSpark(value.wing2, P_RandomFixed(), P_RandomFixed(), P_RandomFixed())
                end
                S_StartSound(nil, sfx_chcdwg)
                S_StartSound(nil, sfx_chcdwg) -- do it twice cuz it's too damn quiet for some reason
            end
            value.started = true
            value.winguses = 0
        end
    end
end}

addCard{name = "Teleporter", chance = FRACUNIT/145, amount = 1, suite = "CHAOS", graphic = "CC_TELE", noboss = true, alwaysrunfunc = true, troll = true,
description = "A rare card; this teleports you to a random spot on the map.", description2 = "Could be the end, could be an inescapable area. Or near a bottomless pit.",
func = function(player, selfid, value, button)
    if button >= 2 and not value.started then
        value.freezex, value.freezey, value.freezez = player.mo.x, player.mo.y, player.mo.z
        P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_RINGBAGENT)
        S_StartSound(player.mo, sfx_s3kb3)
        value.timer = 0
        value.started = true
    end

    if value.started then
        P_SetOrigin(player.mo, value.freezex, value.freezey, value.freezez)
        player.mo.alpha = 0
        value.timer = $ + 1
        player.pflags = $ | PF_FULLSTASIS
        if value.timer > TICRATE/2 + TICRATE/4 then
            local validate = false
            repeat
                local X = P_RandomFixed() * FRACUNIT * ((P_RandomChance(FRACUNIT/2) and -1) or 1)
                local Y = P_RandomFixed() * FRACUNIT * ((P_RandomChance(FRACUNIT/2) and -1) or 1)

                local wallcheck = P_CheckPosition(player.mo, X, Y) -- check for walls/objects
                local subsector = R_PointInSubsectorOrNil(X, Y)

                if wallcheck and subsector then
                    local sector = subsector.sector
                    if GetSecSpecial(sector.special, 1) == 0 or GetSecSpecial(sector.special, 1) > 8 then -- checks for deadly pits... hopefully this works on UDMF maps too
                        local val2 = true
                        for mobj in sector.thinglist() do
                            if mobj.type == MT_SKYBOX then -- check for skybox object; this'll hopefully reduce the chances the player gets put in a skybox zone. it'll still happen for complex ones unfortunately.
                                val2 = false
                            end
                        end
                        -- IMPORTANT TODO: make sure player can actually fit! otherwise they'll get crushed in a thok barrier!
                        if val2 and P_CheckPosition(player.mo, X, Y) then
                            P_SetOrigin(player.mo, X, Y, sector.floorheight)
                            P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_RINGBAGENT)
                            S_StartSound(player.mo, sfx_s3kb3)
                            player.mo.alpha = FRACUNIT
                            validate = true
                        end
                    end
                end
            until validate
            value.amount = $ - 1
        end
    end
end}

addCard{name = "Over Again", chance = FRACUNIT/80, amount = 1, alwaysrunfunc = true, nomultiple = true, graphic = "CC_HOHSIS", nomystery = true, suite = "FANG", noflip = true, noboss = true, troll = true,
description = "You'd do it all over again; get warped back to the last starpost.",
func = function(player, selfid, value, button)
    if value.flip == 0 and value.leaving == 0 and value.flipside == 1 then
        value.timer = $ and $ + 1 or 1
        if value.timer > 5 then
            S_StartSound(player.mo, sfx_chaoag)
            local angle, x, y, z = player.starpostangle, player.starpostx*FRACUNIT, player.starposty*FRACUNIT, player.starpostz*FRACUNIT
            if player.starpostnum == 0 then
                angle, x, y, z = player.ccards.spawna, player.ccards.spawnx, player.ccards.spawny, player.ccards.spawnz
            end
            player.mo.angle = angle
            player.khaossp.warpcooldown = TICRATE
            P_SetOrigin(player.mo, x, y, z)
            value.amount = $ - 1
        end
    end
end}

addCard{name = "Reversed!", chance = FRACUNIT/90, amount = 1, alwaysrunfunc = true, nomultiple = true, nomystery = true, suite = "CHAOS", noflip = true, graphic = "CC_REVERSED", troll = true,
description = "You just got spun around, nerd.",
func = function(player, selfid, value, button)
    if value.flip == 0 and value.leaving == 0 and value.flipside == 1 then
        value.timer = $ and $ + 1 or 1
        if value.timer > 5 then
            S_StartSound(player.mo, sfx_s3kaa)
            player.mo.angle = player.mo.angle + ANGLE_180
            player.mo.momx = -player.mo.momx
            player.mo.momy = -player.mo.momy
            value.amount = $ - 1
        end
    end
end}

addCard{name = "STOP!", chance = FRACUNIT/72, amount = 1, alwaysrunfunc = true, nomultiple = true, nomystery = true, suite = "CHAOS", graphic = "CC_STOP", noflip = true, troll = true,
description = "You violated the law! Or maybe you didn't, but you're forced to stop anyways.",
func = function(player, selfid, value, button)
    if value.flip == 0 and value.leaving == 0 and value.flipside == 1 then
        value.timer = $ and $ + 1 or 1
        if value.timer > 5 then
            S_StartSound(player.mo, sfx_chstop)
            --S_StartSound(player.mo, sfx_s3kb2)
            A_ForceStop(player.mo)
            value.amount = $ - 1
        end
    end
end}

local function ApplyCard(player, card, spawn)
    local actualcard = CCardsTable[card]
    local tabler = {card = card, ranendfunc = true, used = false, amount = actualcard.amount, buffer = true, multiple = 1, mystery = P_RandomChance(FRACUNIT/10), --10% chance it's a mystery card
    flip = 0, flipside = (actualcard.noflip and 1) or 0, leaving = 16}
    if actualcard.foilsave and player.khaossp and player.khaossp[actualcard.foilsave] then
        tabler.foil = true
        if actualcard.foilamount then
            tabler.amount = $ + actualcard.foilamount
        end
    end

    if actualcard.nomystery or tabler.foil then -- remove the mystery. fun fact, the only reason why foil is also checked here... is because foil bugs out the mystery stuff. and i don't know why! so fuck you, it's a feature now! i guess it's beneficial so...
        tabler.mystery = false
    end

    tabler.mysteryPrev = tabler.mystery

    if not spawn then
        S_StartSound(nil, sfx_chcddr, player)
    else
        tabler.leaving = 22 -- extra time
        tabler.mystery = false -- your spawn cards aren't a mystery!
        tabler.mysteryPrev = false
    end

    return tabler
end

local function RunCardFuncs(player, value, button) -- handle all logic here
    local actualcard = CCardsTable[value.card]

    if not value.foil
    and actualcard.foilsave and player.khaossp and player.khaossp[actualcard.foilsave] then -- re-check for foil; done because it can't be done on player spawn lmfao
        value.foil = true
        if actualcard.foilamount then
            value.amount = $ + actualcard.foilamount
        end
    end

    if value.buffer and button == 0 then
       value.buffer = false
    end

    if value.mystery and value.amount != actualcard.amount then
        value.mystery = false -- not a mystery anymore
    end

    if value.flipside == 0 then
        if value.leaving <= 0 then
            value.flip = $ + 1
            if value.flip >= 16 then
                value.flipside = 1
                S_StartSound(nil, sfx_chcdfl, player)
            end
        end
    else
        value.flip = max($ - 1, 0)
    end

    if value.amount > 0 then
        value.leaving = max($ - 1, 0) -- get us back to 0
    end

    if player.playerstate == PST_DEAD then
        if player.starpostnum == 0 and not player.ccards.RedButton then -- restore your cards if you haven't gotten a checkpoint yet
            value.amount = actualcard.amount*value.multiple
            if value.foil and actualcard.foilamount then
                value.amount = (actualcard.amount + actualcard.foilamount)*value.multiple
            end
            player.ccards.cardpile = CalculateCardPileMax(player)
        elseif not player.ccards.burncard and P_RandomChance(FRACUNIT/3) then --1/3 chance for this card to get burnt. who knows, maybe you're the luckiest person in the world and your card never burns!
            value.amount = 0
            player.ccards.burncard = true
        end
    end

    if (player.exiting or (player.pflags & PF_FINISHED)) then
        if actualcard.removemewhenfinished then
            value.amount = 0
        else
            value.amount = actualcard.amount*value.multiple
            if value.foil and actualcard.foilamount then
                value.amount = (actualcard.amount + actualcard.foilamount)*value.multiple
            end
        end
    end

    if player.ccards.justspawned and actualcard.resetonrespawn then
        value.started = false
        value.restart = true
    end

    -- !! SCRIPT CAN RETURN HERE !! --
    if button < 1 then
        if actualcard.endfunc and not value.ranendfunc then
            actualcard.endfunc(player, card, value, button)
            value.ranendfunc = true
        end
        value.used = false
        if not actualcard.alwaysrunfunc then
            return
        end
    end

    if not value.buffer and -- prevents accidental uses right after a card expires
    (actualcard.alwaysrunfunc or
    (((actualcard.maxbuttonval and button < actualcard.maxbuttonval) or not actualcard.maxbuttonval)
    and not value.used
    and ((actualcard.grounded and P_IsObjectOnGround(player.mo)) or not actualcard.grounded)
    ))
    and value.amount > 0
    and not (((player.pflags & PF_FINISHED) and not netgame) or player.playerstate == PST_DEAD or (player.pflags & PF_FULLSTASIS))
    then
        actualcard.func(player, card, value, button)
    end

    if value.mysteryPrev != value.mystery then
        value.flipside = 0
        value.backgraphic = "CC_MYSTERY"
        value.mysteryPrev = value.mystery
    end

    value.mysteryPrev = value.mystery -- TODO: god damnit this was typo'd this entire time, i sure hope me fixing the typo doesn't break things. test this shit

    value.ranendfunc = false
end

local suitevalues = {
["SONIC"] = "sonicsuite",
["AMY"] = "amysuite",
["FANG"] = "fangsuite",
["CHAOS"] = "chaossuite",
}

local function ConstructCardPool(player)
    local tabler = {}
    for key, value in pairs(CCardsTable) do
        if not value.dontdraw then
            if value.suite then
                if player.khaossp[suitevalues[value.suite]] then
                    table.insert(tabler, key)
                end
            elseif value.spsave and player.khaossp[value.spsave] then -- this shouldn't ever not exist if it's not in a suite, but just in case...
                table.insert(tabler, key)
            end
        end
    end

    return tabler
end

local function ChangeTheCard(player, value, other1, other2, memtable) -- a lil jank, i know
    if value.amount < 1 then
        value.leaving = $ + 1
        if value.leaving == 1 then
            S_StartSound(nil, sfx_chcdwd, player)
        end
        local pooltable = ConstructCardPool(player)
        if value.leaving > 16 then
            local currentcard
            local validation
            local multiplegiven = false
            local cycle = 0 -- in case of emergency
            if player.ccards.cardpile > 0 then
                repeat
                    cycle = $ + 1
                    currentcard = pooltable[P_RandomRange(1, #pooltable)]
                    local chancer = CCardsTable[currentcard].chance
                    if cycle > 550 then --we've gone awhile trying to get something, let's try this
                        chancer = $ / 2
                    end
                    validation = P_RandomChance(chancer) -- random ellgibility; do this first since there's a chance it'll return true. that's, like, the whole point.

                    if CCardsTable[currentcard].noboss and (mapheaderinfo[gamemap].bonustype == 1 or mapheaderinfo[gamemap].bonustype == 2) then
                        validation = false
                    end

                    if validation then -- final checks; let's only do this if validation passed before
                        --print("memsize: " .. #memtable)
                        --print("indexofvalue: " .. tostring(indexOfValue(memtable, currentcard)))
                        if indexOfValue(memtable, currentcard) != nil then
                            --print("found in memory: " .. currentcard)
                            validation = false
                        end

                        if (currentcard == other1.card) or (currentcard == other2.card) then
                            validation = false
                            if not multiplegiven and P_RandomChance(FRACUNIT/5) then -- 20% chance of your cards getting multiplied; caps off at 3x
                                if (currentcard == other1.card) then
                                    if other1.multiple < 3 then
                                        other1.multiple = $ + 1, 3
                                        other1.amount = $ + CCardsTable[other1.card].amount
                                        if other1.foil and CCardsTable[other1.card].foilamount then
                                            other1.amount = $ + CCardsTable[other1.card].foilamount
                                        end
                                        multiplegiven = true
                                    end
                                else
                                    if other2.multiple < 3 then
                                        other2.multiple = $ + 1
                                        other2.amount = $ + CCardsTable[other2.card].amount
                                        if other2.foil and CCardsTable[other2.card].foilamount then
                                            other2.amount = $ + CCardsTable[other2.card].foilamount
                                        end
                                        multiplegiven = true
                                    end
                                end
                            end
                        end
                    end
                until ((currentcard != value.card) and validation) or cycle > 800
            else
                currentcard = indexOfName(CCardsTable, "Empty")
                if other1.card == indexOfName(CCardsTable, "Empty") and other2.card == indexOfName(CCardsTable, "Empty") then
                   currentcard = indexOfName(CCardsTable, "Red Button")
                end
            end
            -- insert current card into memory here; and cap out memory slots
            --print("card rolled: " .. value.card)
            table.insert(memtable, value.card)
            local memorysize = 5
            if #pooltable <= 7 then -- only happens if player has 1 suite and not enough other cards
               memorysize = 3
            elseif #pooltable > 10 then -- bump it up just a bit to reduce repetition
               memorysize = 7
            end
            if #memtable > memorysize
                table.remove(memtable, 1)
            end
            -- now we finally return our card
            if cycle > 800 then -- extraordinary case; report immediately. if i start seeing a bunch of these on the forum post i'm gonna cry
                print("WARNING: CYCLE HAS REACHED 800!")
            end
            --print(CCardsTable[value.card].name)
            if not CCardsTable[value.card].troll or (CCardsTable[value.card].troll and not player.khaossp.antitroll) then
                player.ccards.cardpile = max(0, $ - 1)
            elseif player.ccards.cardpile <= 1 then --last card, give them a spare. this'll be hard to test lmao
                player.ccards.cardpile = $ + 1
            end

            return ApplyCard(player, currentcard)
        else
            return value
        end
    else
        return value
    end
end

addHook("ThinkFrame", function()
    if (leveltime % (TICRATE)) == 0 then
        CCards.enabled = tonumber(CV_FindVar("SRB2CE_Cards_Enabled").value)
    end
end)

addHook("PlayerSpawn", function(player)
    if not player.ccards or player.ccards.resetrun then
        player.ccards = {}
        --TODO: consider letting the player choose their starter cards with some small-priced unlock

        local card1, card2, card3 = "Jump", "Spindash", "Thok"

        if SRB2CE.indev then
            card1, card2, card3 = "Jump", "Frog", "Wheel"
        end

        player.ccards.SlotJT = ApplyCard(player, indexOfName(CCardsTable, card1), true)
        player.ccards.SlotST = ApplyCard(player, indexOfName(CCardsTable, card2), true)
        player.ccards.SlotCT = ApplyCard(player, indexOfName(CCardsTable, card3), true)
    end
    player.ccards.frog = nil

    player.ccards.burncard = false

    player.ccards.cardpileMax = CalculateCardPileMax(player)

    if player.ccards.cardpile == nil then
        player.ccards.cardpile = player.ccards.cardpileMax
    end
    --[[if player.ccards.cardpile <= 4 then
        player.ccards.cardpile = player.ccards.cardpileMax
    end]]

    player.ccards.justspawned = true
    player.ccards.buttomtime = 0
    player.ccards.cardpilePrev = nil

    player.ccards.jumpbuffer = 0

    player.ccards.RedButton = false

    player.ccards.memory = {}
    player.ccards.jumpactive = false
    player.ccards.spinactive = false
    player.ccards.soundcalculation = 0
    player.ccards.spawna, player.ccards.spawnx, player.ccards.spawny, player.ccards.spawnz = player.mo.angle, player.mo.x, player.mo.y, player.mo.z

    --reset all currently held cards
    --[[player.ccards.SlotJT = ApplyCard(player, player.ccards.SlotJT.card)
    player.ccards.SlotST = ApplyCard(player, player.ccards.SlotST.card)
    player.ccards.SlotCT = ApplyCard(player, player.ccards.SlotCT.card)]]

    player.ccards.attract = 0

    player.ccards.jump = 0
    player.ccards.spin = 0
    player.ccards.custom = 0

    player.ccards.usingpurplegem = false
end)

addHook("PlayerThink", function(player)
    --print("PF_JUMPED: " .. player.pflags & PF_JUMPED)
    --print("player.ccards.jumpactive: " .. tostring(player.ccards.jumpactive))
    if CCards.Check2Run(player) != player.ccards.enabled then
        if not CCards.Check2Run(player) then -- restore abilities
            player.charability = skins[player.mo.skin].ability
            player.charability2 = skins[player.mo.skin].ability2
            player.charflags = skins[player.mo.skin].flags
        end
    end

    player.ccards.enabled = CCards.Check2Run(player)
    if not CCards.Check2Run(player) then return end

    if player.khaos.OptionsLoaded and not player.ccards.FirstRun then -- have to do this because khaossp hasn't been initalized on player spawn!
        player.ccards.cardpileMax = CalculateCardPileMax(player)

        player.ccards.cardpile = player.ccards.cardpileMax
        if player.ccards.cardpile <= 4 then
            player.ccards.cardpile = player.ccards.cardpileMax
        end

        player.ccards.FirstRun = true
    end

    if player.khaossp.deck3 and player.rings >= 100 and player.ccards.cardpile == 0 then
        player.rings = $ - 100
        S_StartSound(player.mo, sfx_antiri)
        player.ccards.cardpile = player.ccards.cardpileMax + 3
        SRB2CE.addHUDText(player, "Your cardpile has been restocked!", true)
    end

    player.charability = CA_NONE
    player.charability2 = CA2_NONE
    if not (player.charflags & SF_NOSHIELDABILITY) then
        player.charflags = $ | SF_NOSHIELDABILITY
    end

    player.ccards.attract = max($ - 1, 0)

    if player.exiting or (player.pflags & PF_FINISHED) then
       player.ccards.cardpilePrev = player.ccards.cardpile -- used for ring multiplier
       player.ccards.cardpile = player.ccards.cardpileMax
    end

    if (player.powers[pw_carry] and player.powers[pw_carry] != CR_DUSTDEVIL and player.powers[pw_carry] != CR_ZOOMTUBE) or P_InJumpFlipSector(player.mo) then
        player.ccards.jumpbuffer = 3
    end

    if player.ccards.jumpbuffer > 0 then
        player.ccards.jump = 0
        if P_IsObjectOnGround(player.mo) then
            player.ccards.jumpbuffer = $ - 1
        end
    end

    RunCardFuncs(player, player.ccards.SlotJT, player.ccards.jump)
    RunCardFuncs(player, player.ccards.SlotST, player.ccards.spin)
    RunCardFuncs(player, player.ccards.SlotCT, player.ccards.custom)

    player.ccards.SlotJT = ChangeTheCard(player, player.ccards.SlotJT, player.ccards.SlotST, player.ccards.SlotCT, player.ccards.memory)
    player.ccards.SlotST = ChangeTheCard(player, player.ccards.SlotST, player.ccards.SlotJT, player.ccards.SlotCT, player.ccards.memory)
    player.ccards.SlotCT = ChangeTheCard(player, player.ccards.SlotCT, player.ccards.SlotJT, player.ccards.SlotST, player.ccards.memory)

    if player.ccards.spinactive and not (player.pflags & PF_SPINNING) then
        player.ccards.spinactive = false
        player.ccards.soundcalculation = 0
    end

    if not (player.cmd.buttons & BT_JUMP) then
        player.ccards.jump = 0
    end
    if not (player.cmd.buttons & BT_SPIN) then
        player.ccards.spin = 0
    end
    if (player.cmd.buttons & BT_CUSTOM1) then
        player.ccards.custom = $ + 1
    else
        player.ccards.custom = 0
    end

    if player.cmd.buttons & BT_CUSTOM3 then
        player.ccards.SlotJT.flip = TICRATE/3
        player.ccards.SlotST.flip = TICRATE/3
        player.ccards.SlotCT.flip = TICRATE/3
    end

    if player.ccards.frog and player.ccards.frog.valid then
        P_MoveOrigin(player.mo, player.ccards.frog.x, player.ccards.frog.y, player.ccards.frog.z + (P_MobjFlip(player.mo)*(player.ccards.frog.height + (FRACUNIT*32))))
        if P_IsObjectOnGround(player.ccards.frog) or (player.pflags & P_GetJumpFlags(player)) or (player.pflags & PF_SPINNING) or (player.mo.eflags & MFE_GOOWATER) then
            player.ccards.frog = nil
        end
    end

    -- grant player self-destruct card
    if player.khaosbt.custom1 > 1 and player.khaosbt.jump >1 and player.khaosbt.spin > 1 then
        player.ccards.buttomtime = $ + 1
    else
        player.ccards.buttomtime = 0
    end

    if player.ccards.buttomtime >= TICRATE and player.ccards.buttomtime < 5*TICRATE then
        if (player.ccards.buttomtime % TICRATE) == 0 then
            S_StartSound(nil, sfx_menu1, player)
        end
    end

    if player.ccards.buttomtime == 5*TICRATE then
        player.ccards.cardpile = 0
        player.ccards.SlotJT.amount = 0
        player.ccards.SlotST.amount = 0
        player.ccards.SlotCT.amount = 0
    end

    player.ccards.justspawned = false
end)

addHook("JumpSpecial", function(player)
    if CCards.Check2Run(player) then
        if not player.ccards.jumpbuffer then
            player.ccards.jump = $ + 1
            return true
        end
    end
end)

addHook("SpinSpecial", function(player)
    if CCards.Check2Run(player) then
        player.ccards.spin = $ + 1
        return true
    end
end)
