rawset(_G, "SRB2CE", {version = "4.0",
            versiontable = {4, 0, 0}, -- main version, sub version, patch version
            indev = false} -- NOTE: DISABLE ME! if this is enabled after release, you are allowed to laugh at me.
)

rawset(_G, "CCards", {enabled = true})

local CCardsTable = {}
rawset(_G, "CCardsTable", CCardsTable)

SRB2CE.attributions = {
{"EeveeEuphoria/Ibly", "Creator", nil, "KH_IBLY"},
{"sprkizard", "l_fontlib.lua & customsave_io.lua", nil, "KH_SPRKIZARD"},
{"QuickWolfPT & Zipper", "\"Mirror Mode\" mod", "mb.srb2.org/addons/1903", "KH_QWPZ"},
{"Tatsuru", "BootlegAttract function, from Slot Machine", "mb.srb2.org/addons/59", "KH_TAT"},
{"amperbee", "Advice and help from the Kart Krew Dev & SRB2 discord guilds,", "along with sample code for Black Hole, and PBT3.", "KH_AMPERBEE"},
{"CloneFighter", "C. Fighter's Textbox Library", "mb.srb2.org/addons/4487", "KH_CF", 4},
{"Buggie", "Wall Check v1.1", "mb.srb2.org/addons/5085", "KH_BUGGIE"},
{"Othius & Others", "Community Asset Pack", "mb.srb2.org/addons/57", "KH_ATTR"},
{"Chesapeake", "Some designs for Chaos Cards", "\x82Website\x80: moth.monster", "KH_ATTR"},
{"Chara", "Some designs for Chaos Cards", "\x82Website\x80: lesbianblockbuster.com", "KH_ATTR"},
{"Mosa Lina Devs", "Frog/Delete sprites & sounds", "store.steampowered.com/app/2477090", "KH_ATTR"},
{"Golden", "Classic Ring Attraction", "mb.srb2.org/addons/1280", "KH_ATTR"},
{'MIDIMan', "Ringslinger Revolution", "mb.srb2.org/addons/8038", "KH_MIDIMAN"},
{'rrthiel', "overworld music", "\x82Website\x80: rrthiel.bandcamp.com", "KH_RRTHIEL"},
{'John "Joy" Tay', "overworld (ym2151 + ymz280b) remix", "\x82Website\x80: johntayjinf.bandcamp.com", "KH_JJT"},
{'foogle & MasterArt', "overworld foogle remix but I finished it", "youtu.be/WpKxdBAhZPU", "KH_ATTR"},
{"Raxdflipnote", "Gamblecore SFX", nil, "KH_RAXD"}, -- also shoutouts to ProfessorRenderer for the RingboxCore mod; made taking the sounds easier for me
{"Andy Cuccaro", "Tux 3D Model", nil, "KH_ATTR"},
{"Hypnospace Outlaw", "Coin SFX", "\x82Website\x80: www.hypnospace.net", "KH_HSOL"},
{"KroboProductions", '"Oh Okay" voice clip', "\x82Website\x80: youtube.com/@KroboPro", "KH_KROBO"},
{"Cyron", "Omochao Sprites (from Pets: Personal Followers)", "mb.srb2.org/addons/1317", "KH_CYRON"},
{"Sonic Team Jr.", "Sprites from Sonic Robo Blast 2", nil, "KH_STJR"},
{"Kart Krew", "Confetti Graphics, Sound Effects", nil, "KH_KK"},
{"INT10H", "Nixdorf 8810 M15 font", "\x82Website\x80: int10h.org", "KH_ATTR"},
{"Relogic", "Terraria Wing Sprites & Sounds", "\x82Website\x80: re-logic.com", "KH_ATTR"}, -- lol the copyright notice has been stuck since 2021. that was around the time they got screwed over by google, coincidence?
{"marchmountain", "Windows XP High Resolution Icon Pack", nil, "KH_ATTR"},
{"MultiDiegoDani", "Sonic 1 TTS Green Hill Sign Recreated", nil, "KH_MDD"},
{"ChrisFurry", "Evil Tails (previously used for TKK logo)", "\x82Website\x80: chrisfurry.github.io", "KH_CHRIS"},
{"nia", "Playtester for TKK, and provided transparent sprites for PowerMac G4.", "\x82Website\x80: nia.dog", "KH_NIA"},
{"rottingfacade", "indeed cat", "\x82Website\x80: tumblr.com/rottingfacade", "KH_RF"},
{"pixeldonutofcanada91", "Christmas Lights Pixel", nil, "KH_PDOC"},
{"Princess Fluffles", "Playtester, and suggested various effects.", nil, "KH_FLUFFLES"},
}

SRB2CE.optionstableofdoom = {
-- SRB2CE_Blacklist_Set isn't here, it's at the bottom of this script
{name = "SRB2CE_Enabled", values = {0, 1}, typer = "number", localonly = true},
{name = "SRB2CE_Cards_Enabled", values = {0, 1}, typer = "number", localonly = true},
{name = "SRB2CE_Amplify", values = {0, 1}, typer = "number", localonly = true},
{name = "SRB2CE_Universal_Timer", values = {10, 85}, typer = "number", localonly = true},
{name = "SRB2CE_Universal_Fx_Enabled", values = {0, 1}, typer = "number", localonly = true},
{name = "SRB2CEDebug", values = {0, 1}, typer = "number", localonly = true},

{name = "SRB2CE_Memory", values = {0, 14}, typer = "number"},
{name = "SRB2CE_Roulette_SFX", values = {0, 1}, typer = "number"},
{name = "SRB2CE_Print_Effect", values = {0, 1}, typer = "number"},
{name = "SRB2CE_Universal_Announcer", values = {0, 2}, typer = "number"},
{name = "SRB2CE_Ringkeep", values = {0, 1}, typer = "number"},
{name = "SRB2CE_Gamblecore", values = {0, 1}, typer = "number"},
{name = "SRB2CE_HUD", values = {0, 1}, typer = "number"},
{name = "SRB2CE_HUD_Timer_Bar", values = {0, 1}, typer = "number"},
{name = "SRB2CE_Menu_Music", values = {0, 1}, typer = "number"},
{name = "SRB2CE_HUD_Position", values = {0, 1}, typer = "number"},
{name = "SRB2CE_HUD_Text_Border", values = {0, 1}, typer = "number"},
--{name = "SRB2CE_HUD_Override", values = {0, 1}, typer = "number"},
{name = "SRB2CE_HUD_Timer_Color", values = {0, 2}, typer = "number"},
{name = "SRB2CE_HUD_Text_Border_Type", values = {0, 3}, typer = "number"},
{name = "SRB2CE_VarRes", values = {0, 1}, typer = "number"},
}

SRB2CE.optionstableofdoom2 = {
{"SRB2CE_Memory", "number", nil, {0, 14}},
{"SRB2CE_HUD_Timer_Color", "number", nil, {0, 2}},
{"SRB2CE_Roulette_SFX", "boolean"},
{"SRB2CE_Print_Effect", "boolean"},
{"SRB2CE_Universal_Announcer", "boolean"},
{"SRB2CE_Ringkeep", "boolean"},
{"SRB2CE_Gamblecore", "boolean"},
{"SRB2CE_HUD", "boolean"},
{"SRB2CE_HUD_Timer_Bar", "boolean"},
{"SRB2CE_Menu_Music", "boolean"},
{"SRB2CE_HUD_Position", "boolean"},
{"SRB2CE_HUD_Text_Border", "boolean"},
{"SRB2CE_HUD_Override", "boolean"},
{"SRB2CE_HUD_Text_Border_Type", "number", nil, {0, 3}},
{"SRB2CE_VarRes", "boolean"},
}

SRB2CE.items2save = { --IMPORTANT NOTE: ALWAYS ADD ITEMS AT THE BOTTOM OF THE LIST!
 -- first item is name, second item is type, third item means don't count as an unlockable, fourth one is set a default value of this, TODO: fifth is true to disable pop-ups 4 the pop-up system
{"bank", "number", true},
{"ringspent", "number", true},
{"hunter", "bool"},
{"reenterhunter", "bool", true},
{"visitedcity", "bool", true},
{"knuckles", "bool"},
{"amyroof", "bool"},
{"prettycity", "bool"},
{"repairclock", "bool"},
{"annoyingfriend", "bool"},
{"brokenscreen", "bool"},
{"pongmaster", "bool"}, -- done specifically to show up for completionist sake
{"fxpax1", "bool"},
{"rdice", "bool"},
{"starteffect", "bool"},
{"amplifier", "bool"},
{"fxpax2", "bool"},
{"universalfx", "bool"},
{"keepmorerings", "bool"},
{"arcade", "bool"},
{"gamblecore", "bool"},
{"timerbarcolors", "bool"},
{"playerpoints", "number", true},
{"botpoints", "number", true},
{"ringbag", "bool"},
{"drowned", "bool"},
{"starteffectchosen", "number", true},
{"kringscollected", "number", true, 0}, -- amount of rings banked at the end of levels
{"timeshitbykhaos", "number", true, 0}, -- times directly hit by chaos effects
{"ktimespent", "number", true, 0}, -- time spent in levels
{"ringkeep", "bool"},
{"hudtextborder", "bool"},

{"metal", "bool"},
{"permaeffect", "bool"},
{"permaeffectchosen", "number", true},
{"varres", "bool"},
{"nag2", "number", true},

-- v4 starts here

{"chaosdisable", "bool", true},
{"ccardsdisable", "bool", true},
{"sonicsuite", "bool"},
{"amysuite", "bool"},
{"fangsuite", "bool"},
{"chaossuite", "bool"},
{"frogcard", "bool"},
{"whooshcard", "bool"},
{"ringcard", "bool"},
{"deletecard", "bool"},
{"hovercard", "bool"},

{"pgemfoil", "bool"},
{"bouncefoil", "bool"},
{"springfoil", "bool"},
{"sjumpfoil", "bool"},
{"fworkfoil", "bool"},
{"boostfoil", "bool"},
{"jumpfoil", "bool"},
{"deletefoil", "bool"},
{"hoverfoil", "bool"},
{"frogfoil", "bool"},
{"wheelfoil", "bool"},

{"antitroll", "bool"},
{"deck1", "bool"},
{"deck2", "bool"},
{"deck3", "bool"},

--{"emergency", "bool", true},
--{"doubleornothing", "bool"},
--[[{"randomizer", "bool"},
{"renemies", "bool"},
{"rtextures", "bool"},
{"erand1", "bool"},
{"objective", "bool"},]]
}


SRB2CE.AttributeCompareTable =
{
amplifyonly = " * Amplify Mode exclusive effect.",
drainrespawntimer = " * Timer goes down during respawn.",
noblacklist = " * Can't be blacklisted.",
dontrollme = " * Can't be rolled for by the Roulette.",
nobees = " * Can't be rolled for by \"You Get The Bees\".",
startexception = " * Can't be selected for \"On-start Effect\".",
grounded = " * Player needs to be on ground for this to apply.",
immune2remove = " * Can't be removed by \"Remove Random Effect\"",
--beyond this point is only nessecary for ring racers, but idk any non-jank way to stop this from appearing in srb2kart
noghost = " * Player can't have been affected by a Hyudoro.",
requirerings = " * Requires >1 ring to apply.",
nospecialstage = " * Doesn't apply in special stages.",
nonights = " * Doesn't apply in NiGHTS stages.",
norock = " * Doesn't apply while on a rollout rock.",
nocart = " * Doesn't apply while riding a minecart.",
nobattle = " * Doesn't apply in battle mode.",
battleonly = " * Battle mode exclusive effect.",
nobot = " * Can't be applied to bots.",
ignoremultiplier = " * Disabling won't affect your Ring Multiplier.",
}

local KhaosEffectsTable = {}
rawset(_G, "KhaosEffectsTable", KhaosEffectsTable)

local SRB2CE_Enabled = 1
rawset(_G, "SRB2CE_Enabled", SRB2CE_Enabled)

rawset(_G, "Khaos_ListOMenus", {})

rawset(_G, "khaos_rainbowtext", function(string, offset) -- if you use this, leave this credit for me: Ibly/EeveeEuphoria
    local indexer = 0
    if offset then
        indexer = offset
    end
    local colortable = {"\x85", "\x87", "\x82", "\x83", "\x8B", "\x84", "\x8C", "\x89", "\x81"} -- length is 9
    local rainbowed = ""

    for c in string:gmatch"." do
        if c != " " then
            indexer = $ + 1
            if indexer > #colortable then
                indexer = 1
            end
            c = colortable[indexer] + $
        end
        rainbowed = $ + c
    end
    return rainbowed
end)

freeslot(
"S_COLORRING",
"sfx_chmony",
"MT_JIMBO",
"S_CHAOTICPIZZA",
"SPR_CHPI",
"SPR_CHMK",
"SPR_CTUX",
"S_CHAOSTUX",
"SPR_CWIN",
"S_CHAOSWIN9X",
"S_CHAOSMAC",
"S_CHAOSSKULL",
"sfx_chslrp",
"sfx_chmark",
"sfx_chmini",
"sfx_chapis",
"sfx_chapki",
"sfx_boo",
"sfx_slappy",
"sfx_chgc",
"S_CHAOTICXPLOSPIZZA",
"S_CHAOTICPIZZAFACE",
"SPR_SOSS",
"S_SOSS_RUN1",
"S_SOSS_RUN2",
"S_SOSS_RUN3",
"S_SOSS_RUN4",
"S_SOSS_RUN5",
"S_SOSS_RUN6",
"S_KHAOSMAKRED",
"MT_MARKED4DEATH",
"S_KHAOSMINICRIT",
"MT_KHAOSMINICRIT",
--[["SPR_CEIB",
"SPR_CEIC",
"SPR_CEID",
"SPR_CDVD",]]
"SPR_CHPF",
"sfx_chadet",
"sfx_camin",
"sfx_chstop",
"sfx_camout",
"sfx_chcake",
"sfx_chrewi",
"sfx_chyeet",
"sfx_chyee2",
"sfx_chlank",
"sfx_chtxed",
"sfx_chtxst",
"sfx_chtxad",
"MT_ICESHRAPNELCHAOTIC", "S_ICESHRAPCH", "S_ICESHRAP2CH", "S_ICESHRAP3CH", "S_ICESHRAP4CH", "SPR_ISHK", "SPR_ISHC",
"MT_CHANGESPRITE",
"MT_LAGPLAYER",
--s.a.m. voices
"sfx_cbees", -- you get the bees
"sfx_cbees2",
"sfx_cposwa", -- position swap
"sfx_cposw2",
"sfx_cwacky", -- wacky textures
"sfx_cwack2",
"sfx_cattra", -- attractive player
"sfx_cattr2",
"sfx_coutwo", -- out of this world
"sfx_coutw2",
"sfx_cexlif", -- extra life
"sfx_cexli2",
"sfx_ctimes", -- timestop
"sfx_ctime2",
"sfx_crings", -- negative rings
"sfx_cring2",
--ms sam voices
"sfx_mbees", -- you get the bees
"sfx_mbees2",
"sfx_mwacky", -- wacky textures
"sfx_mwack2",
"sfx_mposwa", -- position swap
"sfx_mposw2",
"sfx_mattra", -- attractive player
"sfx_mattr2",
"sfx_moutwo", -- out of this world
"sfx_moutw2",
"sfx_mexlif", -- extra life
"sfx_mexli2",
"sfx_mtimes", -- timestop
"sfx_mtime2",
"sfx_mrings", -- negative rings
"sfx_mring2",

"sfx_chbomb", -- bombz

"SPR_CMAC",
"SPR_CSKL",

"sfx_talks", "sfx_talk0", "sfx_chtam", "sfx_chtfa", "sfx_chtta",
"sfx_lggamb", "sfx_dangit", "sfx_gbcjac", -- all taken from the ring racers gamblecore mod lol, thanks for doing the hard work for me
"sfx_ohokay",

"SPR_CHCL",
"MT_KHAOSCLOCK",
"S_KHAOSCLOCK1",
"S_KHAOSCLOCK2",
"S_KHAOSCLOCK3",

"SPR_CHOM", -- SKINCOLOR_ICY
"S_CHAOSOMOCHAO",
"MT_CHAOSOMO",
"sfx_chhiom",
"sfx_chanom",
"sfx_chdeom",
"sfx_cabomb",

"sfx_chwarp",

"sfx_choin1", "sfx_choin2", "sfx_choin3",
"MT_KHAOSAMY", "MT_KHAOSTAILS", "MT_KHAOSFANG", "MT_KHAOSKNUX", "MT_KHAOSMETAL",
"MT_KHAOSFIGTLS",
"S_KHAOSFIGURE1",
"MT_KHAOSMAPWARP",
"MT_KHAOSRINGBAG", "S_KHAOSRINGBAG", "SPR_CHRB", "MT_KHAOSFAKERING",

"sfx_chping",
"sfx_chpong",
"sfx_chpggo",
"SPR_CMSP", "S_RINGBAGENTERANCE", "MT_RINGBAGENT",

"sfx_ksquee",

"sfx_tmxsuc", -- THESE ARE RING RACERS SOUNDS, DON'T RE-IMPORT THESE

-- chaos cards
"sfx_chcdwd", "sfx_chcddr", "sfx_chcdfl", "sfx_chcdwg", "sfx_chcdw2", "SPR_CHWG", "S_CCWINGS", "S_CCWINGSF", "MT_CCWINGS", "S_CCWINGSFR", "S_CCWINGSFRF", "sfx_chaoag", "sfx_chbost", "sfx_chslip", "sfx_chwast", "sfx_chwasd",
"MT_CHAOSFROG", "S_CHAOSFROG", "S_CHAOSFROGHOP", "S_CHAOSFROGDIE", "sfx_chfrog", "sfx_chfroj", "sfx_chfrod", "SPR_CHFR",
"SPR_CHDX", "sfx_chdel1", "sfx_chdel2", "S_CHAOSDELETE", "S_CHAOSDELETEACTIVE", "MT_CHAOSDELETE",
"SPR_CHHV", "S_CHAOSCARD", "MT_CHAOSCARD",
"sfx_chwhl", "sfx_chwhl2"
)

if not sfx_gshd9 then -- future-proofing if STJR decides to add the sounds that ring racers has
    freeslot("sfx_gshd9", "sfx_gshd2", "sfx_gshc4")
end

states[S_CHAOSCARD] = {
    sprite = SPR_CHHV,
    frame = A|FF_PAPERSPRITE,
    tics = -1,
}

mobjinfo[MT_CHAOSCARD] = {
    doomednum = -1,
    spawnstate = S_CHAOSCARD,
    --deathstate = S_CHAOSDELETEACTIVE,
    spawnhealth = 1000,
    radius = 36*FRACUNIT,
    height = 96*FRACUNIT,
    flags = MF_NOCLIP|MF_SPECIAL
}


states[S_CHAOSDELETE] = {
    sprite = SPR_CHDX,
    frame = A,
    tics = -1,
}

states[S_CHAOSDELETEACTIVE] = {
    sprite = SPR_CHDX,
    frame = B,
    tics = -1,
}

mobjinfo[MT_CHAOSDELETE] = {
    doomednum = -1,
    spawnstate = S_CHAOSDELETE,
    --deathstate = S_CHAOSDELETEACTIVE,
    spawnhealth = 1000,
    radius = 24*FRACUNIT,
    height = 24*FRACUNIT,
    flags = MF_NOCLIP|MF_NOGRAVITY
}

states[S_CHAOSFROG] = {
    sprite = SPR_CHFR,
    frame = A,
    tics = -1,
}

states[S_CHAOSFROGHOP] = {
    sprite = SPR_CHFR,
    frame = B,
    tics = -1,
}

states[S_CHAOSFROGDIE] = {
    sprite = SPR_CHFR,
    frame = C,
    tics = -1,
}

mobjinfo[MT_CHAOSFROG] = {
    doomednum = -1,
    spawnstate = S_CHAOSFROG,
    deathstate = S_CHAOSFROGDIE,
    spawnhealth = 1000,
    radius = 20*FRACUNIT,
    height = 23*FRACUNIT,
    flags = MF_SOLID
}

states[S_CCWINGS] = {
	sprite = SPR_CHWG,
	frame = FF_PAPERSPRITE|FF_ANIMATE|A,
	tics = -1,
	var1 = 3,
	var2 = 3,
    nextstate = S_CCWINGSFR
}

states[S_CCWINGSF] = {
	sprite = SPR_CHWG,
	frame = FF_PAPERSPRITE|FF_ANIMATE|E,
	tics = -1,
	var1 = 3,
	var2 = 3,
    nextstate = S_CCWINGSFRF
}

states[S_CCWINGSFR] = {
	sprite = SPR_CHWG,
	frame = FF_PAPERSPRITE|C,
	tics = -1,
	var1 = 0,
	var2 = 0,
}
states[S_CCWINGSFRF] = {
	sprite = SPR_CHWG,
	frame = FF_PAPERSPRITE|G,
	tics = -1,
	var1 = 0,
	var2 = 0,
}

mobjinfo[MT_CCWINGS] = {
	doomednum = -1,
	spawnstate = S_CCWINGS,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	dispoffset = 1, -- always display in front of player
	flags = MF_NOCLIP|MF_NOGRAVITY
}

addHook("MobjThinker", function(mobj)
    local playermo = mobj.target
    if mobj.target and mobj.target.valid then
        local player = playermo.player
        local x = playermo.radius/2
        if mobj.wing == 2 then
            x = -$
        end
        mobj.angle = player.drawangle
        mobj.scale = playermo.scale
        local xmove = playermo.x + P_ReturnThrustX(mobj, mobj.angle, FixedMul(-1*FRACUNIT, mobj.scale)) -- stole this from SRB2's source code lol
        local ymove = playermo.y + P_ReturnThrustY(mobj, mobj.angle, FixedMul(-1*FRACUNIT, mobj.scale))
        mobj.angle = $ + ANGLE_90
        P_MoveOrigin(mobj, xmove, ymove, playermo.z+(P_MobjFlip(mobj)*(playermo.height/2 + playermo.height/4)))
    else
        P_RemoveMobj(mobj)
    end
end, MT_CCWINGS)

addHook("MobjThinker", function(mobj)
    if not mobj.started then
        mobj.timer = 14
        mobj.started = true
    end

    mobj.timer = $ - 1

    if mobj.floorsink == nil then -- something went wrong, abort
        P_RemoveMobj(mobj)
    end

    if mobj.timer == 0 then
        S_StartSound(delete, sfx_chdel2)
        mobj.state = S_CHAOSDELETEACTIVE

        local m = mobj
        local range = mobj.radius + (40 * mobj.scale)
        local range2 = range - (8*FRACUNIT)
        searchBlockmap("objects", function(ref, found)
            if found and found.valid then
                if R_PointToDist2(m.x, m.y, found.x, found.y) <= range2 and P_CheckSight(m, found)
                and (abs((found.z - mobj.z)/FRACUNIT) < 32) then
                    if found.valid then
                        if found.player then
                            if not mobj.foil and R_PointToDist2(m.x, m.y, found.x, found.y) <= range2/4 then -- make the radius shorter for the player; more forgiving
                                P_KillMobj(found)
                            end
                        else
                            P_RemoveMobj(found)
                        end
                    end
                end
            end
        end, m, m.x-range, m.x+range, m.y-range, m.y+range)

        --print(mobj.floorsink/FRACUNIT)
        --print(mobj.expectedfloor/FRACUNIT)

        if mobj.flipma then
            if mobj.floorsink > mobj.expectedfloor then
                if mobj.subsector then
                    local sector = mobj.subsector.sector
                    if sector then
                        sector.ceilingheight = mobj.floorsink
                    end
                end
            end
        else
            if mobj.floorsink < mobj.expectedfloor then
                if mobj.subsector then
                    local sector = mobj.subsector.sector
                    if sector then
                        sector.floorheight = mobj.floorsink
                    end
                end
            end
        end
    end



    if mobj.timer <= -15 then
        P_RemoveMobj(mobj)
    end

end, MT_CHAOSDELETE)

addHook("MobjThinker", function(mobj)
    if mobj.state != S_CHAOSFROGDIE then
        if not mobj.started then
            mobj.delay = $ or TICRATE
            mobj.selfdestruct = $ or TICRATE*15
            mobj.scale = $ + ($/3)
            mobj.shadowscale = mobj.scale/2
            mobj.wallblock = 0
            mobj.started = true
        end

        if P_IsObjectOnGround(mobj) then
            mobj.delay = $ - 1
            mobj.state = S_CHAOSFROG
            if mobj.delay <= 0 then
                mobj.delay = TICRATE
                S_StartSound(mobj, sfx_chfroj)
                mobj.state = S_CHAOSFROGHOP

                local m = mobj
                local range = mobj.radius + (64 * mobj.scale) --sizable range; should account for falling off the frog too, i hope
                local range2 = range - (8*FRACUNIT)
                searchBlockmap("objects", function(ref, found)
                    if found.type == MT_PLAYER then
                        if R_PointToDist2(m.x, m.y, found.x, found.y) <= range2 and P_CheckSight(m, found)
                        and (abs((found.z - mobj.z)/FRACUNIT) < mobj.height+(6*FRACUNIT)) then
                            if found.valid then
                                found.player.ccards.frog = mobj
                                found.z = $ + FRACUNIT*20
                                mobj.angle = found.player.drawangle
                                mobj.lastplayer = found.player -- TODO: use this to award points to enemies killed or hit by the player's frog. also use this to collect items for the player
                            end
                        end
                    end
                end, m, m.x-range, m.x+range, m.y-range, m.y+range)

                P_SetObjectMomZ(mobj, 20*FRACUNIT)
                P_InstaThrust(mobj, mobj.angle, (FixedMul(15*FRACUNIT, mobj.scale)))

                mobj.angle = $ + (P_RandomRange(-30, 30)*ANG1)
                --TODO: scan for objects right on top of the frog, and add this momentum to them
            end
        end

        if (leveltime % TICRATE/3) == 0 then
            local m = mobj
            local range = mobj.radius + (20 * mobj.scale)
            local range2 = range - (8*FRACUNIT)
            searchBlockmap("objects", function(ref, found)
                if found.flags & MF_ENEMY then
                    if R_PointToDist2(m.x, m.y, found.x, found.y) <= range2 and P_CheckSight(m, found)
                    and (abs((found.z - mobj.z)/FRACUNIT) < 32) then
                        if found.valid then
                            P_DamageMobj(found)
                        end
                    end
                end
            end, m, m.x-range, m.x+range, m.y-range, m.y+range)
        end

        mobj.wallblock = max($ - 1, 0)

        mobj.selfdestruct = $ - 1

        if mobj.state == S_CHAOSFROGHOP then
            mobj.flags = $ & ~MF_SOLID
        else
            mobj.flags = $ & MF_SOLID
        end

        if mobj.selfdestruct <= 0 then
            mobj.state = S_CHAOSFROGDIE
            mobj.flags = $ & ~MF_SOLID
            S_StartSound(mobj, sfx_chfrod)
        end
    end

end, MT_CHAOSFROG)


sfxinfo[sfx_talks].caption = "/"
sfxinfo[sfx_talk0].caption = "/"
sfxinfo[sfx_chtam].caption = "/"
sfxinfo[sfx_chtfa].caption = "/"
sfxinfo[sfx_chtta].caption = "/"

states[S_RINGBAGENTERANCE] = {
	sprite = SPR_CMSP,
	frame = FF_ANIMATE,
	tics = 15,
	var1 = 5,
	var2 = 3,
	nextstate = S_INVISIBLE
}

mobjinfo[MT_RINGBAGENT] = {
	doomednum = -1,
	spawnstate = S_RINGBAGENTERANCE,
	spawnhealth = 1000,
	radius = 64*FRACUNIT,
	height = 64*FRACUNIT,
	dispoffset = 1,
	flags = MF_NOCLIP|MF_NOGRAVITY
}


states[S_KHAOSRINGBAG] = {
    sprite = SPR_CHRB,
    frame = A|FF_PAPERSPRITE,
    tics = -1,
}

mobjinfo[MT_KHAOSFAKERING] = {
    doomednum = -1,
    spawnstate = S_COLORRING,
    deathstate = S_SPRK1,
    deathsound = sfx_itemup,
    radius = 15*FRACUNIT,
    height = 24*FRACUNIT,
    speed = 38*FRACUNIT,
    flags = MF_SLIDEME --|MF_SPECIAL
}

mobjinfo[MT_KHAOSRINGBAG] = {
    doomednum = -1,
    spawnstate = S_KHAOSRINGBAG,
    radius = 25*FRACUNIT,
    height = 30*FRACUNIT,
    flags = MF_NOGRAVITY|MF_SPECIAL
}

states[S_CHAOSOMOCHAO] = {
    sprite = SPR_CHOM,
    frame = A|FF_ANIMATE,
    tics = -1,
    var1 = 3,
    var2 = 2,
}

states[S_KHAOSCLOCK1] = {
    sprite = SPR_CHCL,
    frame = A|FF_PAPERSPRITE,
    tics = -1,
}

states[S_KHAOSCLOCK2] = {
    sprite = SPR_CHCL,
    frame = B|FF_PAPERSPRITE,
    tics = -1,
}

states[S_KHAOSCLOCK3] = {
    sprite = SPR_CHCL,
    frame = C|FF_PAPERSPRITE,
    tics = -1,
}

mobjinfo[MT_KHAOSCLOCK] = {
    doomednum = -1,
    spawnstate = S_KHAOSCLOCK1,
    speed = 36*FRACUNIT,
    height = 128*FRACUNIT,
    radius = 25*FRACUNIT,
    flags = MF_NOGRAVITY|MF_NOCLIP
}

states[S_KHAOSFIGURE1] = {
    sprite = SPR_PLAY,
    frame = A,
    tics = -1,
    --frame = TR_TRANS50
}

local FIGTABLE = {
    doomednum = -1,
    spawnstate = S_KHAOSFIGURE1,
    radius = 16*FRACUNIT,
    height = 48*FRACUNIT,
    flags = MF_RUNSPAWNFUNC|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

mobjinfo[MT_KHAOSAMY] = FIGTABLE
mobjinfo[MT_KHAOSTAILS] = FIGTABLE
mobjinfo[MT_KHAOSFANG] = FIGTABLE
mobjinfo[MT_KHAOSKNUX] = FIGTABLE
mobjinfo[MT_KHAOSMETAL] = FIGTABLE

mobjinfo[MT_KHAOSFIGTLS] = {
    doomednum = -1,
    spawnstate = S_TAILSOVERLAY_STAND,
    radius = 16*FRACUNIT,
    height = 48*FRACUNIT,
    flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

mobjinfo[MT_CHAOSOMO] = {
    doomednum = -1,
    spawnstate = S_CHAOSOMOCHAO,
    deathstate = S_XPLD_FLICKY,
    --speed = 40*FRACUNIT,
    height = 25*FRACUNIT,
    radius = 13*FRACUNIT,
    deathsound = sfx_chdeom,
    flags = MF_RUNSPAWNFUNC|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

mobjinfo[MT_KHAOSMAPWARP] = {
    doomednum = -1,
    spawnstate = S_INVISIBLE,
    --speed = 40*FRACUNIT,
    height = 48*FRACUNIT,
    radius = 32*FRACUNIT,
    flags = MF_NOGRAVITY|MF_SPECIAL
}

states[S_CHAOTICPIZZAFACE] = {
    sprite = SPR_CHPF,
    frame = FF_ANIMATE|FF_GLOBALANIM,
    --tics = 4,
    var1 = 15,
    var2 = 2,
    nextstate = S_CHAOTICPIZZAFACE
}


states[S_COLORRING] = {
    sprite = SPR_TRNG,
    frame = FF_ANIMATE|FF_GLOBALANIM,
    tics = -1,
    var1 = 23,
    var2 = 1,
    nextstate = S_COLORRING
}

states[S_SOSS_RUN1] = {
    sprite = SPR_SOSS,
    frame = A,
    tics = 3,
    nextstate = S_SOSS_RUN2
}

states[S_SOSS_RUN2] = {
    sprite = SPR_SOSS,
    frame = B,
    tics = 3,
    nextstate = S_SOSS_RUN3
}

states[S_SOSS_RUN3] = {
    sprite = SPR_SOSS,
    frame = C,
    tics = 3,
    nextstate = S_SOSS_RUN4
}

states[S_SOSS_RUN4] = {
    sprite = SPR_SOSS,
    frame = D,
    tics = 3,
    nextstate = S_SOSS_RUN5
}

states[S_SOSS_RUN5] = {
    sprite = SPR_SOSS,
    frame = E,
    tics = 3,
    nextstate = S_SOSS_RUN6
}

states[S_SOSS_RUN6] = {
    sprite = SPR_SOSS,
    frame = F,
    tics = 3,
    nextstate = S_SOSS_RUN1
}

states[S_CHAOSTUX] = {
    sprite = SPR_CTUX,
    tics = -1
}

states[S_CHAOSWIN9X] = {
    sprite = SPR_CWIN,
    tics = -1
}


states[S_CHAOSMAC] = {
    sprite = SPR_CMAC,
    tics = -1
}

states[S_CHAOSSKULL] = {
    sprite = SPR_CSKL,
    tics = -1
}


states[S_CHAOTICPIZZA] = {
    sprite = SPR_CHPI,
    tics = -1
}

states[S_CHAOTICXPLOSPIZZA] = {
    sprite = SPR_CHPI,
    frame = B,
    tics = -1
}

states[S_KHAOSMAKRED] = {
    sprite = SPR_CHMK,
    frame = A,
    tics = -1
}

states[S_KHAOSMINICRIT] = {
    sprite = SPR_CHMK,
    frame = B,
    tics = -1
}

mobjinfo[MT_JIMBO] = {
    doomednum = -1,
    spawnstate = S_CHAOTICPIZZA,
    speed = 36*FRACUNIT,
    height = 128*FRACUNIT,
    radius = 25*FRACUNIT,
    flags = MF_NOGRAVITY|MF_NOCLIP
}

mobjinfo[MT_MARKED4DEATH] = {
    doomednum = -1,
    spawnstate = S_KHAOSMAKRED,
    radius = 32*FRACUNIT,
    height = 32*FRACUNIT,
    flags = MF_NOGRAVITY|MF_NOCLIP
}

mobjinfo[MT_KHAOSMINICRIT] = {
    doomednum = -1,
    spawnstate = S_KHAOSMINICRIT,
    radius = 32*FRACUNIT,
    height = 32*FRACUNIT,
    flags = MF_NOGRAVITY|MF_NOCLIP
}


mobjinfo[MT_CHANGESPRITE] = {
    doomednum = -1,
    spawnstate = S_COLORRING,
    radius = 16*FRACUNIT,
    height = 48*FRACUNIT,
    flags = MF_NOGRAVITY|MF_NOCLIP
}

mobjinfo[MT_LAGPLAYER] = {
    doomednum = -1,
    spawnstate = S_COLORRING,
    radius = 16*FRACUNIT,
    height = 48*FRACUNIT,
    flags = MF_NOGRAVITY|MF_NOCLIP
}

sfxinfo[sfx_chapis] = {
    singular = false,
    priority = 64,
    flags = SF_X4AWAYSOUND,
    --caption = "The pizza is aggressive!"
}

sfxinfo[sfx_chapki] = {
    singular = false,
    priority = 129,
    --caption = "\"Oh shit.\""
}

sfxinfo[sfx_boo] = {
    singular = false,
    priority = 64,
    --caption = "BoOoO!"
}

sfxinfo[sfx_slappy] = {
    singular = false,
    priority = 64,
    --caption = "Slapped"
}

sfxinfo[sfx_chgc] = {
    singular = false,
    priority = 64,
    --caption = "Coiled spring"
}

sfxinfo[sfx_chadet] = {
    singular = false,
    priority = 64,
    --caption = "Flare gun"
}

states[S_ICESHRAPCH] = {SPR_ISHK, A, -1, nil, 0, 0, S_NULL}
states[S_ICESHRAP2CH] = {SPR_ISHK, B, -1, nil, 0, 0, S_NULL}
states[S_ICESHRAP3CH] = {SPR_ISHK, C, -1, nil, 0, 0, S_NULL}
states[S_ICESHRAP4CH] = {SPR_ISHK, D, -1, nil, 0, 0, S_NULL}

mobjinfo[MT_ICESHRAPNELCHAOTIC] = {
    doomednum = -1,
    spawnstate = S_ICESHRAPCH,
    height = 5*FRACUNIT,
    radius = 5*FRACUNIT,
    flags = MF_NOCLIPTHING
}

SRB2CE.rainbowcolors = { -- Rainbow Table, feel free to use yourself if you credit EeveeEuphoria/Ibly!
"35",
"34",
"56",
"55",
"54",
"53",
"52",
"51",
"50",
"74",
"73",
"188",
"96",
"112",
"122",
"255",
"123",
"124",
"134",
"135",
"136",
"137",
"150",
"151",
"152",
"167",
"166",
"165",
"184",
"183",
"182",
"181",
"202",
"203",
"204",
--"210",
--"211",
"212"
}

SRB2CE.AmplifyChecker = function(player)
    if not player then player = players[0] end --assume host
    if tonumber(CV_FindVar("SRB2CE_Amplify").value)
    and player.khaossp.amplifier then --TODO BUG :this doesn't work in netplay? why?
        return true
    else
        return false
    end
end

SRB2CE.DebugPrint = function(player, text)
    if tonumber(CV_FindVar("SRB2CEDebug").value)
        local playertext = (player and "PLYR: " + player.name + ", ") or ""
        print(playertext + "TEXT: " + text)
    end
end

SRB2CE.IsMatchMode = function()
    local header = mapheaderinfo[gamemap].typeoflevel
    if (header & TOL_MATCH) or (header & TOL_TAG) or (header & TOL_CTF) then
        return true
    end

    return false
end

SRB2CE.addHUDText = function(player, string, override, extend, color)
    if not player.khaosoptions.SRB2CE_HUD and not override then return end
    extend = extend or 0 -- can't wait to not remember to fix all my code that doesn't do this
    local tbl = {text = string, trans = 0, timer = 0, expire = ((4 + extend)*TICRATE)- player.khaos.addHUDTextRando, color = color}
    local sendplayer = player

    table.insert(sendplayer.khaostext, tbl)
    sendplayer.khaos.addHUDTextRando = P_RandomRange(5, 10) -- done for text added one after another, to randomize the timer a bit

    SRB2CE.DebugPrint(player, player.name + ": " + string)
end

rawset(_G, "Khaos_SaveSettings", function(player, silent)
    for key, valuable in pairs(SRB2CE.optionstableofdoom) do
        if not valuable.localonly  --TODO: allow admin to save their own local/netvar settings
        and not valuable.dontsave then
            local name = "client/srb2chaoticedition/" .. valuable.name .. ".dat"
            local savefile = io.openlocal(name, "w")
            if savefile != nil then
                local Saver = CV_FindVar(valuable.name).value
                if player and player.khaosoptions then
                    Saver = player.khaosoptions[valuable.name]
                end
                local TheValue = savefile:write(Saver)
                savefile:close()
            end
        end
    end
    if player and player.khaos and not silent then
        SRB2CE.addHUDText(player, "\199" + "Saved settings!", true, 4)
        S_StartSound(player.mo, sfx_addfil, player)
    --else
        --CONS_Printf(player, khaos_rainbowtext("Saved settings!"))
    end
end)

rawset(_G, "Khaos_LoadSettings", function(player)
    if player and player.khaos then player.khaos.LoadFailed = false end -- reset this at the start
    local sindex = 0
    local optionsloaded = 0 -- count how many files we load. if it's 0, this is a fresh install!
    local chunks = (netgame and 1) or 69
    for key, value in pairs(SRB2CE.optionstableofdoom) do
        if (optionsloaded < chunks) or not player then
            if not value.localonly -- TODO: make it so admins can load this, but only once! make a netvar called "AdminLoadedSettings" to prevent other admins auto-loading
            and not value.dontsave then
                sindex = $ + 1
                local name = "client/srb2chaoticedition/" .. value.name .. ".dat"
                --print(value.name)
                local loadedfile = io.openlocal(name, "r")
                if loadedfile != nil then
                    if ((player and player.khaos.OptionsLoadAmount <= sindex) or not player) then
                        optionsloaded = $ + 1
                        if player then player.khaos.OptionsLoadAmount = $ + 1 end
                        local TheValue = loadedfile:read("*all")
                        local TheType = "zkhaosNUM " -- the space is important, don't forget this
                        if value.typer == "string" then
                            TheType = "zkhaosSTR "
                        end
                        if player then
                            COM_BufInsertText(player or consoleplayer, TheType + value.name + " " + TheValue)
                        else --consoleplayer is loading this
                            COM_BufInsertText(consoleplayer, value.name + " " + TheValue)
                        end
                    end
                    io.close(loadedfile)
                end
            end
        end
    end


    if player and player.khaos.OptionsLoadAmount == player.khaos.OptionsPreviousLoad then
        if player and player.khaos then player.khaos.OptionsLoaded = true end
    end
end)

-- !! khaosPBT3 !! --

-- &
local thosbutons = {
    "up","down","left","right",
    "spin","jump",
    "attack","nextwep","prevwep",
    "custom1","custom2","custom3",
    "moving","hmoving","vmoving",
    "attacknormal", "camleft", "camright", "tossflag" -- EeveeEuphoria additions
}
for k,v in ipairs(thosbutons) do
    thosbutons[v] = true
end

--NOTE: this has been modified specifically for mmt, and now khaos,, all "p.bt..." variables have been converted to "p.khaosbt..." so it doesn't conflict with any other mod that uses this system

rawset(_G, "pbtDaemonkhaos", function(p)
    --if deepcopy == nil then error("deepcopy missing", 2) end
    -- Does a cool thing
    local cmdbt = p.cmd.buttons
    local cmdfm = p.cmd.forwardmove
    local cmdsm = p.cmd.sidemove

    if not p.khaosbttimestamp then p.khaosbttimestamp = -1 end

    if p.khaosbttimestamp ~= leveltime then
        -- Prevent this from running more than once if multiple daemons are in place (why would there be more than one)

        if not p.khaosbt then
            p.khaosbt = {}
            p.khaosbtx = {}
            p.khaosbtprev = {}
            for _,v in ipairs(thosbutons) do
                p.khaosbt[v] = 0
                p.khaosbtprev[v] = 0
                p.khaosbtx[v] = 0
            end
        end
        local sens = 20

        for i = 1,#thosbutons do
            local ix = thosbutons[i]
            p.khaosbtprev[ix] = p.khaosbt[ix]
        end -- Old values

        p.khaosbt.up = cmdfm > sens and $+1 or 0
        p.khaosbt.down = cmdfm < -sens and $+1 or 0
        p.khaosbt.right = cmdsm > sens and $+1 or 0
        p.khaosbt.left = cmdsm < -sens and $+1 or 0

        if p.khaosbt.up > 0 and p.khaosbt.down > 0 then p.khaosbt.up = 0; p.khaosbt.down = 0 end
        if p.khaosbt.right > 0 and p.khaosbt.left > 0 then p.khaosbt.right = 0; p.khaosbt.left = 0 end

        p.khaosbt.spin = (cmdbt & BT_USE) > 0 and $+1 or 0
        p.khaosbt.jump = (cmdbt & BT_JUMP) > 0 and $+1 or 0
        p.khaosbt.attack = (cmdbt & BT_ATTACK) > 0 and $+1 or 0
        p.khaosbt.attacknormal = (cmdbt & BT_FIRENORMAL) > 0 and $+1 or 0

        p.khaosbt.tossflag = (cmdbt & BT_TOSSFLAG) > 0 and $+1 or 0

        p.khaosbt.camleft = (cmdbt & BT_CAMLEFT) > 0 and $+1 or 0
        p.khaosbt.camright = (cmdbt & BT_CAMRIGHT) > 0 and $+1 or 0

        p.khaosbt.nextwep = (cmdbt & BT_WEAPONNEXT) > 0 and $+1 or 0
        p.khaosbt.prevwep = (cmdbt & BT_WEAPONPREV) > 0 and $+1 or 0

        p.khaosbt.custom1 = (cmdbt & BT_CUSTOM1) > 0 and $+1 or 0
        p.khaosbt.custom2 = (cmdbt & BT_CUSTOM2) > 0 and $+1 or 0
        p.khaosbt.custom3 = (cmdbt & BT_CUSTOM3) > 0 and $+1 or 0

        p.khaosbt.hmoving = (p.khaosbt.left or p.khaosbt.right) and $~=nil and $+1 or 0
        p.khaosbt.vmoving = (p.khaosbt.up or p.khaosbt.down) and $~=nil and $+1 or 0
        p.khaosbt.moving = (p.khaosbt.up or p.khaosbt.down or p.khaosbt.left or p.khaosbt.right) and $~=nil and $+1 or 0

        local sum = 0
        local sidesum = 0

        if cmdsm < 0 then sidesum = 45 end
        if cmdsm > 0 then sidesum = -45 end

        if cmdfm == 0 then sidesum = $*2 end
        if cmdfm < 0 then sidesum = -sidesum;sum = 180 end

        local res = sum + sidesum
        --return FixedAngle( res*FRACUNIT )
        p.khaosbt.dirAsAngle = FixedAngle( res*FRACUNIT )

        p.khaosbttimestamp = leveltime
    end
end)

--[[
&pbt usage:

p.khaosbt holds button held time
p.khaosbtprev holds the value in the previous frame for that respective button

Want to check if a player is holding jump?
p.khaosbt.jump > 0

Want to check for a tap on the jump button (not held, but the instant it is pressed)?
p.khaosbt.jump == 1

Want to check when jump was just released?
p.khaosbt.jump < p.khaosbtprev.jump
normally btprev is smaller than bt when the button is held, so if it is larger, it must have been released


or use one of the shortcut functions like a baby
]]

local function checks(p, key)
    if not p then error("Bad argument #1 (expected player)", 3) end
    if not p.khaosbt then
        error("Are you running pbtDaemonkhaos()?", 3)
    end
    if key == nil then error("Key argument is nil", 3) end
    if not thosbutons[key] then
        error("Button "..key.." not in the list", 3)
    end
end

rawset(_G, "PBTkhaos_Up", function(p, key) checks(p,key)
    return not p.khaosbt[key] -- If 0, true
end)
rawset(_G, "PBTkhaos_Down", function(p, key) checks(p,key)
    return not not p.khaosbt[key] -- If >0, true
end)

rawset(_G, "PBTkhaos_JustPressed", function(p, key) checks(p,key)
    -- Button has just been pressed after not being pressed
    return p.khaosbt[key] and p.khaosbtprev[key] == 0
end)
rawset(_G, "PBTkhaos_JustReleased", function(p, key) checks(p,key)
    -- Button is no longer being pressed after being pressed press press press press press press press press press press
    return p.khaosbt[key] < p.khaosbtprev[key]
end)


--[[
* l_fontlib.lua
* (sprkizard), (modified by EeveeEuphoria, to support ring racers, add support SOC colors, and add alpha)
* (Dec 6, 2021 16:51), (Jun 14, 2024 01:51)
* Desc: A custom drawstring function that can
        use custom font sets

* Usage: TODO
]]

rawset(_G, "Fontlib", {})

Fontlib.defaultspace = 4
Fontlib.defaultreturn = 4

Fontlib.fontinfo = {
    ["CRFNT"] = {upperonly=true},
    ["LTFNT"] = {},
    --["NTFNO"] = {},
    --["NTFNT"] = {upperonly=true},
    ["STCFN"] = {spacewidth=4, returnheight=4},
    ["TNYFN"] = {spacewidth=2, returnheight=5},
    ["MKFNT"] = {spacewidth=4, upperonly=true},
    ["FILE"] = {upperonly=true},
    ["CRFNT"] = {upperonly=true},
    ["GAMEM"] = {},
    ["MNUFN"] = {},
}

-- Creates an entry for custom font info (width between letters, return spacing, etc)
function Fontlib.setFontAttr(font, t)
    t = t or {} -- done to allow for laziness
    Fontlib.fontinfo[font] = {}
    for k,v in pairs(t) do
        Fontlib.fontinfo[font][k] = v
    end
end

-- Checks if the fontinfo entry exists, and gets the supplied attribute of it
function Fontlib.getFontAttr(font, attr)
    return (Fontlib.fontinfo[font] and Fontlib.fontinfo[font][attr])
end

-- Wrapper for validating table contents used here, and using them
function Fontlib.getAttr(t, key, attr)
    return (t[key] and t[key][attr])
end

-- Returns the width what the string as patches would be,
-- and returns all cached patches in a table
-- function Fontlib.GetInternalFontWidth(str, font)
function Fontlib.cachePatchWidth(v, str, font, space)

    -- No string
    if not (str) then return 0 end

    local patches = {}
    local width = 0

    for i=1,#str do

        local char = str:sub(i,i)

        -- Spaces before fonts. Use accurate font space widths or revert to defaults
        if char:byte() == 32 then
            width = $1 + (Fontlib.getFontAttr(font, "spacewidth") or 4)
            continue
        end
        -- Ignore skincolors completely
        if char:byte() >= 128 and char:byte() <= 199 then
            continue
        end
        -- TODO: count special characters?
        if char:byte() >= 200 and char:byte() <= 203 then
            -- width = $1+8
            continue
        end

        -- Create patch name format
        local patchname = string.format("%s%03d", font, char:byte())

        -- TODO: some patches do not exist, and the fix below may not be enough
        if not (v.patchExists(patchname)) then patches[char:byte()] = nil continue end

        -- Cache patches assigned by byte number
        if not (patches[char:byte()]) then
            -- Avoid caching the same character twice
            patches[char:byte()] = v.cachePatch( patchname )
        end
        width = $1 + (patches[char:byte()].width or 8) + space

    end
    return {patches=patches, linewidth=width}
end

function Fontlib.invalidCharPatch(patchlist, char)
    return patchlist[char:byte()] == nil and true or false
end

-- TODO: separate text effects
-- function Fontlib.stringEffects(x, y, char, time)
-- end

-- TODO: Find a way to capture embedded flags
-- (eg. Font swapping with format: t[font..char:byte()] to cache multiple characters))
--[[function Fontlib.gettextflag()
    local keypos = 0
    local ahead = 0

    if keypos and (pos >= keypos and pos <= ahead) then return end
    if line:sub(pos, pos+5) == "<test:" then

        keypos = pos
        ahead = pos+6

        local capture = ""

        for j=ahead, #line do
            if (line:sub(j, j) == ">") ahead = $1+#capture break end
            capture = $1 .. line:sub(j, j)
            -- print(keypos.."|"..str:sub(j, j))
        end
        x = capture
        return
    end
end--]]


function Fontlib.drawString(v, sx, sy, text, flags, align)

    -- Font Options
    local font = (flags and flags.font) or "STCFN"
    local uppercs = (flags and flags.upper) or false
    local ramp = (flags and flags.ramp) or nil -- Custom rainbow color
    local marspeed = (flags and flags.marspeed) or 4 -- Rainbow marquee speed
    local alpha = (flags and flags.alpha and flags.alpha<<V_ALPHASHIFT) or 0
    local color = nil

    -- Constants
    local spacewidth = (Fontlib.getFontAttr(font, "spacewidth") or 4)

    -- Scale adjustments
    local scale = (flags and flags.scale) or FRACUNIT
    local hscale = (flags and flags.hscale) or 0
    local vscale = (flags and flags.vscale) or 0

    -- Spacing
    local xspace = (flags and flags.xspace) or 0
    local yspace = (flags and flags.yspace) or (Fontlib.getFontAttr(font, "returnheight") or 4)

    -- Color equivalents to classic SOC colors
    local colorswap = (flags and flags.soccolors) or {SKINCOLOR_LAVENDER, SKINCOLOR_YELLOW, SKINCOLOR_GREEN, SKINCOLOR_BLUE, SKINCOLOR_RED, SKINCOLOR_GREY, SKINCOLOR_ORANGE, SKINCOLOR_CYAN, SKINCOLOR_PURPLE, SKINCOLOR_NOBLE, SKINCOLOR_GALAXY, SKINCOLOR_MAGENTA, SKINCOLOR_ROSY, SKINCOLOR_BROWN, SKINCOLOR_SIBERITE}

    -- Extra flags, useful for snap to top or bottom
    local extraflags = (flags and flags.extraflags) or 0

    -- Split our string into new lines from line-breaks
    local lines = {}

    for breaks in text:gmatch("[^\r\n]+") do
        table.insert(lines, breaks)
    end

    -- Interate through the text blocks (alignment should always go last before char drawing)
    for seg=1,#lines do

        local line = lines[seg]

        -- Screen x and y positions
        local x = sx
        local y = sy

        -- Text effects
        local off_x = 0
        local off_y = 0
        local swirl = 0
        local shake = 0
        local rainbow = 0
        local rcolors = ramp or {SKINCOLOR_RUBY, SKINCOLOR_ORANGE, SKINCOLOR_YELLOW, SKINCOLOR_MINT, SKINCOLOR_AQUAMARINE, SKINCOLOR_PASTEL, SKINCOLOR_ROSY}

        -- Current (+backwards) character & font patch (hopeful optimization)
        local bchar
        local char
        local charpatch

        -- Fixed is no longer an alignment option, and is now a flag
        if not (flags and flags.fixed) then
            x = $1 << FRACBITS
            y = $1 << FRACBITS
        end

        -- V_ALLOWLOWERCASE flag replacement
        if (uppercs or Fontlib.getFontAttr(font, "upperonly")) then
            line = tostring(line):upper()
        end

        -- Get used character patches and the width of the line
        -- TODO: character spacing does not work correctly
        local cache = Fontlib.cachePatchWidth(v, line, font, xspace)

        -- Text block alignment settings
        if (align == "center") then
            x = $1-FixedMul( cache.linewidth/2, scale) << FRACBITS
        elseif (align == "right") then
            x = $1-FixedMul( cache.linewidth, scale) << FRACBITS
        end


        -- v.drawString(320/2, 150+seg*8, "Line Length: "+#line, 0, "thin")
        for pos=1,#line do
            (function()

                -- String sub each character
                char = line:sub(pos, pos)

                -- Text Effects
                -- TODO: separate text effects
                -- ========
                -- Text Effect: Rainbow color
                if (char:byte() == 199) then
                    color = nil
                    rainbow = leveltime/marspeed + #line
                    return
                end

                -- Text Effect: Text color (Custom skincolors unsupported, only MAXSKINCOLORS allowed.)
                if (char:byte() == 128) or (char:byte() == 144) then
                    color = nil
                    rainbow = 0
                    return
                elseif (char:byte() >= 129 and char:byte() <= 143) then
                    color = v.getColormap(TC_DEFAULT, colorswap[char:byte() - 128])
                    rainbow = 0
                    return
                elseif (char:byte() >= 145 and char:byte() <= 198) then
                    color = v.getColormap(TC_DEFAULT, char:byte() - 144)
                    rainbow = 0
                    return
                end

                -- Stop effects
                if (char:byte() == 200) then
                    swirl = 0
                    shake = 0
                    off_x = 0
                    off_y = 0
                    return
                end

                -- Text Effect: That one undertale groove effect
                if (char:byte() == 201) then
                    swirl = leveltime*2
                    shake = 0
                    return
                end

                -- Text Effect: That one deltarune shake effect
                if (char:byte() == 202) then
                    shake = (leveltime/1)*(leveltime/1)*3
                    swirl = 0
                    return
                end

                if (rainbow) then
                    color = v.getColormap(TC_DEFAULT, rcolors[((rainbow-pos) % #rcolors)+1])
                end

                if (swirl) then
                    swirl = $1+2
                    off_x = (cos(ANG10*(swirl)))
                    off_y = (sin(ANG10*(swirl)))
                end

                if (shake) then
                    shake = ($1+1)*($1+FRACUNIT)
                    off_x = (cos(ANG10*shake))
                    shake = ($1+1)*($1+FRACUNIT)
                    off_y = (sin(ANG10*shake))
                end
                -- ========

                -- Prevent spaces and non-existent characters from drawing altogether
                if not char:byte() or char:byte() == 32 then
                    x = $1+spacewidth*scale
                    return
                end

                -- Weird return spacing fix by getting the previous character
                bchar = line:sub(pos-1, pos)

                -- If a character has no patch: prevent from drawing
                if (Fontlib.invalidCharPatch(cache.patches, char)) then return end

                -- Draw the current character given
                v.drawStretched(x+off_x, y+off_y, scale+hscale, scale+vscale, cache.patches[char:byte()], alpha|extraflags, color or v.getColormap(TC_DEFAULT, 1))

                -- Sets the space between each character using the font's width
                x = $1 + (xspace+cache.patches[char:byte()].width)*scale

            end)()
        end
        -- For control code effects, try to get the last character height
        local cheight = Fontlib.getAttr(cache.patches, char:byte(), "height")
        local bcheight = bchar and Fontlib.getAttr(cache.patches, bchar:byte(), "height") -- for some reason, bchar can sometimes be nil, and that causes problems.
        -- Break new lines by spacing and patch height for source-accurate spacing
        local linespacing = FixedMul( (yspace + (cheight or bcheight or 4) )*FRACUNIT, scale )
        sy = $1 + ((flags and flags.fixed) and linespacing or linespacing >> FRACBITS)

    end
end

local Font1 = "KHFNT"
local Font2 = "KHMNT"

Fontlib.setFontAttr(Font1, {spacewidth=2}) -- font i made :)
Fontlib.setFontAttr(Font2, {spacewidth=3}) -- the Nixdorf 8810 M15 font

-- Example
--[[hud.add(function(v, stplyr, cam)

    -- v.drawFill(320/2, 0, 1, v.height(), 35)

    -- Vanilla
    v.drawString(320/2, 0, "Fontlib\n-Version 2-\nCustom Text Drawer", 0, "left")

    -- Fontlib
    local text = "\201Fontlib\200\n-Version 2-\n\202Custom Text Drawer\200"
    Fontlib.drawString(v, 320/2, 32, text, {font="STCFN"}, "center")
    Fontlib.drawString(v, 320/2, 64, text, {font="CRFNT"}, "center")
    Fontlib.drawString(v, 320/2, 128, text, {font="LTFNT"}, "center")

end, "game")
--]]

-- !! TextboxLibrary / CloneFighterTextBoxes !! --

-- The main library for the textboxes.
-- Made by Clone Fighter; v1.0.0
rawset(_G, "CFTextBoxes", {
    version = {1, 0, 0}, -- Major, minor, hotfix
    globalBox = {}
})

local function BreakUpText(v, s) -- lol
    local str = {s}
    local i = 1
    while v.stringWidth(str[i], V_ALLOWLOWERCASE, "normal") > 306 do
        if i > 5 then break end

        str[i+1] = str[i]
        local a
        while true do
            str[i] = string.sub($, 1, -2)
            if v.stringWidth(str[i], V_ALLOWLOWERCASE, "normal") <= 306 and (string.sub(str[i], -1, -1) == " " or string.find(str[i], "\n")) then
                if string.find(str[i], "\n") then str[i] = string.sub($, 1, string.find($, "\n")-1) else str[i] = string.sub(str[i], 1, -2) end
                a = string.len(str[i])
                break
            end
        end
        str[i+1] = string.sub($, a+2, -1)
        i = $+1

        if string.find(str[i], "\n") then
            str[i+1] = string.sub(str[i], string.find(str[i], "\n")+1, -1)
            str[i] = string.sub($, 1, string.find($, "\n")-1)

            if str[i]:len() == 0 then
                str[i] = str[i+1]
                str[i+1] = ""
            end
        end
        str[i+2] = str[i+1]
    end

    if string.find(str[i], "\n") then
        str[i+1] = string.sub(str[i], string.find(str[i], "\n")+1, -1)
        str[i] = string.sub($, 1, string.find($, "\n")-1)

        if str[i]:len() == 0 then
            str[i] = str[i+1]
            str[i+1] = ""
        end
    end

    if str[i+2] == str[i+1] then str[i+2] = "" end
    return str
end

local TB = CFTextBoxes -- shortcut

-- Set up a textbox set. This makes the affected player unable to move, just so that they can interact with the textbox.
-- You can set a delay for the textboxes to close/progress automatically in their options.
-- You are also able to disable the control lock, in which case you cannot interact with the textbox. Default delay is set to 3 seconds.
-- And of course, you can make the box display globally.
function TB:DisplayBox(player, table, move)
    if player then
        player.textBox = {
            tree = table,
            current = 1,
            move = move
        }
    else
        self.globalBox = {
            tree = table,
            current = 1,
            move = move,
            global = true
        }
        for p in players.iterate do
            p.textBox = self.globalBox
        end
    end
end

-- Close any box the player might have up.
function TB:CloseBox(player)
    if player then player.textBox = {}
    else self.globalBox = {} end
end

-- Advance.
-- if you're reading this clonefighter, i am so so sorry for what i've done to your code.
function TB.AdvanceBox(player)
    if player.textBox.choice then player.textBox.current = player.textBox.tree[player.textBox.current].choices[player.textBox.choice].box
        player.textBox.choice = 0
    else
        if player.textBox.tree[player.textBox.current].next != 0 then
            player.textBox.current = player.textBox.tree[$].next
        else
            if not player.textBox.delayend then
                player.textBox.delayend = (TICRATE/2) + (TICRATE/4) -- jank ass way to do this; i can't be bothered to do it a better way
            end
        end
    end

    if not player.textBox.delayend then
        if player.textBox.current != 0 and player.textBox.tree[player.textBox.current].script then
            player.textBox.tree[player.textBox.current].script(player)
        end
        player.textBox.settings = {
            timer = 1,
            atonce = 1,
            prev = nil,
            curt = 1,
            copied = 0,
            wait = 0,
            mode = {},
            escape = {}
        }
        player.textBox.render = ""
        player.textBox.txfilter = nil
    end
end

-- Box handler

--[[addHook("KeyDown", function(keyevent)
    -- spaget
    local aa, ab = input.gameControlToKeyNum(GC_STRAFELEFT)
    local ac, ad = input.gameControlToKeyNum(GC_STRAFERIGHT)
    local ba, bb = input.gameControl2ToKeyNum(GC_STRAFELEFT)
    local bc, bd = input.gameControl2ToKeyNum(GC_STRAFERIGHT)

    if keyevent.num == aa or keyevent.num == ab then
        move = -1
    elseif keyevent.num == ac or keyevent.num == ad then
        move = 1
    end
    if keyevent.num == ba or keyevent.num == bb then
        move2 = -1
    elseif keyevent.num == bc or keyevent.num == bd then
        move2 = 1
    end
end)]]

local punct = {
    ["."] = true,
    [","] = true,
    [";"] = true,
    [":"] = true,
    ["?"] = true,
    ["!"] = true,
}

addHook("PlayerThink", function(player)
    player.textBox = $ or {}
    if not player.textBox.tree then if not player.textBox.complete then player.textBox = TB.globalBox end; return end
    if player.textBox.global and not TB.globalBox.tree then player.textBox = {}; return end

    if not player.textBox.move then player.pflags = $|PF_FULLSTASIS; player.powers[pw_flashing] = 1 end

    local box = player.textBox
    local tree = box.tree
    local curbox = tree[player.textBox.current]

    -- KeyDown momento
    -- NOTICE: modified for khaos to fix bug w/ controllers, by just using amperbee's bt system
    -- ...this also might fix it in netplay, i just realized.
    local move = 0

    if player.khaosbt.left == 1 or (player.khaosbt.left > 20 and (leveltime % 2 == 0)) then
        move = -1
    elseif player.khaosbt.right == 1 or (player.khaosbt.right > 20 and (leveltime % 2 == 0)) then
        move = 1
    end

    if player == consoleplayer then player.select = move end
    --elseif player == secondarydisplayplayer then player.select = move2 end

    if curbox.choices then
        box.choice = $ or 1

        if player.select then
            box.choice = $+player.select
            if box.choice > #curbox.choices then box.choice = 1
            elseif box.choice < 1 then box.choice = #curbox.choices end
            S_StartSound(nil, sfx_menu1, player)
        end
    end

    -- Onto the box.
    box.render = $ or ""
    box.settings = $ or {
        timer = 1,
        atonce = 1,
        prev = nil,

        curt = 1,
        copied = 0,

        wait = 0,
        mode = {},
        escape = {}
    }
    if curbox.text then
        box.txfilter = curbox.text
        local i = 1
        while i < #box.txfilter do
            while string.sub(box.txfilter, i, i) == '|' do
                if string.sub(box.txfilter, i+1, i+3) == "del" or string.sub(box.txfilter, i+1, i+3) == "pau" then
                    box.txfilter = string.sub($, 1, i-1) .. string.sub($, i+6, -1)
                elseif string.sub(box.txfilter, i+1, i+3) == "shk" or string.sub(box.txfilter, i+1, i+3) == "esc" then
                    box.txfilter = string.sub($, 1, i-1) .. string.sub($, i+5, -1)
                elseif string.sub(box.txfilter, i+1, i+3) == "wav" or string.sub(box.txfilter, i+1, i+3) == "rst" then
                    box.txfilter = string.sub($, 1, i-1) .. string.sub($, i+4, -1)
                else
                    break
                end
            end
            i = $+1
        end
    end

    if box.txfilter and box.render != box.txfilter then
        box.settings.curt = $-1
        if box.settings.curt == 0 then
            box.settings.curt = box.settings.timer

            local iter = 0
            while iter < box.settings.atonce do
                box.settings.copied = $+1
                local cpy = string.sub(curbox.text, box.settings.copied, box.settings.copied)
                while cpy == "|" do
                    box.settings.copied = $+3
                    cpy = string.sub(curbox.text, box.settings.copied-2, box.settings.copied)
                    local vd = false

                    if cpy == "del" then
                        box.settings.copied = $+2
                        local x, y = tonumber(string.sub(curbox.text, box.settings.copied-1, box.settings.copied-1)) or 1,
                                tonumber(string.sub(curbox.text, box.settings.copied, box.settings.copied)) or 1
                        box.settings.atonce, box.settings.timer = x, y
                        vd = true
                    elseif cpy == "pau" then
                        box.settings.copied = $+2
                        local x = tonumber(string.sub(curbox.text, box.settings.copied-1, box.settings.copied)) or 1
                        box.settings.curt = $+x
                        vd = true
                        iter = box.settings.atonce --hack to stop right here
                    elseif cpy == "shk" then
                        box.settings.copied = $+1
                        local x = tonumber(string.sub(curbox.text, box.settings.copied, box.settings.copied))
                        box.settings.mode[#box.render+1] = x
                        vd = true
                    elseif cpy == "esc" then
                        box.settings.copied = $+1
                        box.settings.escape[#box.render+1] = string.sub(curbox.text, box.settings.copied, box.settings.copied)
                        vd = true
                    elseif cpy == "wav" then
                        box.settings.mode[#box.render+1] = 4
                        vd = true
                    elseif cpy == "rst" then
                        box.settings.mode[#box.render+1] = 0
                        vd = true
                    end

                    if vd then
                        box.settings.copied = $+1
                        cpy = string.sub(curbox.text, box.settings.copied, box.settings.copied)
                    else
                        box.settings.copied = $-3
                        cpy = string.sub(curbox.text, box.settings.copied, box.settings.copied)
                        break
                    end
                end
                box.render = $..cpy
                iter = $+1

                if box.settings.mode[#box.render] == nil then box.settings.mode[#box.render] = box.settings.mode[#box.render-1] or 0 end
                if not box.settings.escape[#box.render] then box.settings.escape[#box.render] = box.settings.escape[#box.render-1] or "\x80" end
            end
            if curbox.sound then S_StartSound(nil, curbox.sound, player) end

            if punct[string.sub(box.render, -1, -1)] then box.settings.curt = $*4 end
        end
    else
        box.settings.wait = $+1
        if curbox.delay and box.settings.wait == curbox.delay then TB.AdvanceBox(player) end
    end

    if player.cmd.buttons & BT_JUMP and not player.textBox.move then
        if not box.txfilter or box.render == box.txfilter then
            if not player.boxadvance then
                TB.AdvanceBox(player)
            end
        else
            if not player.boxadvance then box.settings.prev = box.settings.atonce end
            if box.settings.prev then box.settings.atonce = box.settings.prev*5; box.settings.curt = 1 end
        end
        player.boxadvance = true
    else if player.boxadvance and box.settings.prev then box.settings.atonce = box.settings.prev; box.settings.prev = nil end; player.boxadvance = false end

    if player.cmd.buttons & BT_SPIN and not player.textBox.move then
        if box.txfilter and box.render != box.txfilter then
            if not player.boxskip then box.settings.prev = box.settings.atonce end
            box.settings.atonce = string.len(box.txfilter); box.settings.curt = 1
        end
        player.boxskip = true
    else if player.boxskip and box.settings.prev then box.settings.atonce = box.settings.prev; box.settings.prev = nil end; player.boxskip = false end

    if player.textBox.current == 0 then
        if not player.textBox.move then player.powers[pw_flashing] = TICRATE/2 end
        player.textBox = {complete = true}
    return end


    if player.textBox.delayend then
        player.textBox.delayend = $ - 1
        if player.textBox.delayend <= 0 then
           player.textBox.current = 0
           player.textBox = {complete = true}
        end
    end

    -- reset
    move = 0
end)

local posTable = {
    up = {x = 160, y = 155, a = "center"},
    down = {x = 160, y = 183, a = "center"},
    left = {x = 7, y = 169, a = "left"},
    right = {x = 313, y = 169, a = "right"},
    ul = {x = 7, y = 155, a = "left"},
    ur = {x = 313, y = 155, a = "right"},
    dl = {x = 7, y = 183, a = "left"},
    dr = {x = 313, y = 183, a = "right"},
    center = {x = 160, y = 169, a = "center"}
}
local cursTable = {
    up = {x = 152, y = 163},
    down = {x = 152, y = 191},
    left = {x = 7, y = 177},
    right = {x = 296, y = 177},
    ul = {x = 7, y = 163},
    ur = {x = 296, y = 163},
    dl = {x = 7, y = 191},
    dr = {x = 296, y = 191},
    center = {x = 152, y = 177}
}

-- Box drawer
local function textboxStringDrawer(v, x, y, sss, f, box)
    local t = BreakUpText(v, sss)

    for i, str in ipairs(t) do
        local space = 0
        if not (box and box.settings) then return end
        for j = 1, #str do
            local k = 0
            for l = 1, i-1 do
                if t[l] then k = $+#t[l]+1 end
            end
            local rendstr = str:sub(j,j)
            if box.settings.escape[j+k] then rendstr = box.settings.escape[j+k]..$ end

            if box.settings.mode[j+k] == 0 then -- Normal
                v.drawString(x+space, y+8*(i-1), rendstr, f)
            elseif box.settings.mode[j+k] == 4 then -- Wavy
                v.drawString(x+space, y+8*(i-1)+(2*sin(FixedAngle(ease.linear(((j+leveltime)%10)*FRACUNIT/10, 0, 360)*FRACUNIT))/FRACUNIT), rendstr, f)
            else -- Shake
                local shkchnc = {FRACUNIT/20, FRACUNIT/5, FRACUNIT/2}
                local randx,randy = 0,0
                if v.RandomChance(shkchnc[box.settings.mode[j+k]]) then
                    randx,randy = v.RandomRange(-1,1),v.RandomRange(-1,1)
                end
                v.drawString(x+space+randx, y+8*(i-1)+randy, rendstr, f)
            end
            space = $+v.stringWidth(rendstr, f)
        end
    end
end

SRB2CE.tbHUD = function(v, player)
    if not player.textBox or not player.textBox.tree then v.timer = 0 v.delayend = nil return end
    local tb = player.textBox
    local box = tb.tree[tb.current]

    -- global offset; added in SRB2:CE
    local globalyoffset = 0
    local maxtime = (TICRATE/2)
    if v.delayend then
        maxtime = $ + (TICRATE/4) - 1
    end

    if player.textBox.delayend and not v.delayend then
        v.delayend = true
        v.timer = 0
    end

    if v.timer < maxtime then
        local algo, starter, ender = ease.outexpo, 100*FRACUNIT, 0
        if v.delayend then
            algo, starter, ender = ease.inexpo, 0, 100*FRACUNIT
        end
        globalyoffset = max(algo((FRACUNIT*v.timer) / maxtime, starter, ender), 0)
    else
        globalyoffset = 0 -- to be fair i could've capped the timer. but maybe this is more efficient, since we're not doing a math calculation every frame lol
    end
    v.timer = $ + 1

    -- Portrait
    if box.portrait then
        local spr, flip = v.getSprite2Patch(box.portrait[1], box.portrait[2], false, box.portrait[3], box.portrait[4])
        local colr = v.getColormap(box.portrait[1], box.color)
        v.drawScaled(32*FRACUNIT, 146*FRACUNIT + (spr.topoffset*FRACUNIT/3) + globalyoffset, skins[box.portrait[1]].highresscale, spr, (flip and V_FLIP or 0)|V_SNAPTOBOTTOM, colr)
    end

    -- Box
    v.draw(0, 146+(globalyoffset/FRACUNIT), v.cachePatch("TBOXBACK"), V_SNAPTOBOTTOM)
    if box.name then v.drawString(48, 138+(globalyoffset/FRACUNIT), box.name, V_YELLOWMAP|V_SNAPTOBOTTOM) end

    if tb.render then
        textboxStringDrawer(v, 7, 153+(globalyoffset/FRACUNIT), tb.render, V_SNAPTOBOTTOM|V_ALLOWLOWERCASE, tb)
    end

    if box.choices then
        local e = ""
        for i, j in ipairs(box.choices) do
            local h = (tb.choice == i) and V_YELLOWMAP or 0
            v.drawString(posTable[j.pos].x, posTable[j.pos].y+(globalyoffset/FRACUNIT), j.text, V_SNAPTOBOTTOM|V_ALLOWLOWERCASE|h, posTable[j.pos].a)
            if tb.choice == i then e = j.pos end
        end
        if e and cursTable[e] then v.draw(cursTable[e].x, cursTable[e].y+(globalyoffset/FRACUNIT), v.cachePatch("M_CURSOR"), V_SNAPTOBOTTOM) end
    end

    if box.mini then
        for i, j in ipairs(box.mini) do
            local a = "thin-"..posTable[j.pos].a
            if a == "thin-left" then a = "thin" end

            local spr = v.getSprite2Patch(j.portrait[1], SPR2_TBXM, false, j.portrait[2], 1)
            local col = v.getColormap(j.portrait[1], j.color)

            if tb.settings.wait < 2+i and tb.settings.wait > i then
                if a == "thin" then
                    v.draw(posTable[j.pos].x+8, posTable[j.pos].y+10+(globalyoffset/FRACUNIT), spr, V_SNAPTOBOTTOM|V_50TRANS, col)
                    v.drawString(posTable[j.pos].x+16, posTable[j.pos].y+2+(globalyoffset/FRACUNIT), j.text, V_SNAPTOBOTTOM|V_ALLOWLOWERCASE|V_50TRANS, a)
                elseif a == "thin-right" then
                    v.draw(posTable[j.pos].x-8, posTable[j.pos].y+10+(globalyoffset/FRACUNIT), spr, V_SNAPTOBOTTOM|V_FLIP|V_50TRANS, col)
                    v.drawString(posTable[j.pos].x-16, posTable[j.pos].y+2+(globalyoffset/FRACUNIT), j.text, V_SNAPTOBOTTOM|V_ALLOWLOWERCASE|V_50TRANS, a)
                else
                    v.draw(posTable[j.pos].x-(v.stringWidth(j.text, V_ALLOWLOWERCASE, "thin")/2), posTable[j.pos].y+10+(globalyoffset/FRACUNIT), spr, V_SNAPTOBOTTOM|V_50TRANS, col)
                    v.drawString(posTable[j.pos].x+8, posTable[j.pos].y+2+(globalyoffset/FRACUNIT), j.text, V_SNAPTOBOTTOM|V_ALLOWLOWERCASE|V_50TRANS, a)
                end
            elseif tb.settings.wait >= 2+i then
                if a == "thin" then
                    v.draw(posTable[j.pos].x+8, posTable[j.pos].y+8+(globalyoffset/FRACUNIT), spr, V_SNAPTOBOTTOM, col)
                    v.drawString(posTable[j.pos].x+16, posTable[j.pos].y+(globalyoffset/FRACUNIT), j.text, V_SNAPTOBOTTOM|V_ALLOWLOWERCASE, a)
                elseif a == "thin-right" then
                    v.draw(posTable[j.pos].x-8, posTable[j.pos].y+8+(globalyoffset/FRACUNIT), spr, V_SNAPTOBOTTOM|V_FLIP, col)
                    v.drawString(posTable[j.pos].x-16, posTable[j.pos].y+(globalyoffset/FRACUNIT), j.text, V_SNAPTOBOTTOM|V_ALLOWLOWERCASE, a)
                else
                    v.draw(posTable[j.pos].x-(v.stringWidth(j.text, V_ALLOWLOWERCASE, "thin")/2), posTable[j.pos].y+8+(globalyoffset/FRACUNIT), spr, V_SNAPTOBOTTOM, col)
                    v.drawString(posTable[j.pos].x+8, posTable[j.pos].y+(globalyoffset/FRACUNIT), j.text, V_SNAPTOBOTTOM|V_ALLOWLOWERCASE, a)
                end
            end
        end
    end
end

--! extremely chopped up bits of ringkeep.lua !--

addHook("PlayerThink", function(player) if player.bot > 0 return end
    if not SRB2CE_Enabled and not tonumber(CV_FindVar("SRB2CE_Cards_Enabled").value) then return end
    if SRB2CE.IsMatchMode() then return end --this would crash v2.2.13 otherwise lol, we don't need to be running this in match mode anywho
    if not tonumber(CV_FindVar("SRB2CE_Ringkeep").value) then return end

    if P_PlayerInPain(player) and player.khaos.RingPainTime
        local theminuser = ((player.khaosPreviousRings*FRACUNIT) - (FixedMul(player.khaosPreviousRings*FRACUNIT, FRACUNIT/2)))/FRACUNIT -- i'm so sorry for this
        if player.khaossp.keepmorerings then
            theminuser = ((player.khaosPreviousRings*(FRACUNIT)) - (FixedMul(player.khaosPreviousRings*FRACUNIT, FRACUNIT/3)))/FRACUNIT -- 1/3, meaning you keep 2/3
        end
        player.rings = theminuser
        player.khaos.RingsLost = player.khaosPreviousRings - theminuser
        P_PlayerRingBurst(player, player.khaos.RingsLost)
        player.khaos.RingsLost = 1
        player.khaos.RingPainTime = false
    end

    if player.playerstate == PST_DEAD and not player.khaosIJustDied
        player.khaosIJustDied = true
    end

    if player.khaosIJustDied and player.playerstate == PST_LIVE -- can't use reborn, since for whatever reason it runs *before* the player actually respawns
        if mapheaderinfo[gamemap].bonustype == 1 and player.khaosPreviousRings < 10
            return
        end
        player.rings = player.khaosPreviousRings/2
        player.khaosIJustDied = false
    end

    if player.playerstate == PST_LIVE then
        player.khaosPreviousRings = player.rings
    end
end) --mobjdamage stuff moved to khaos script; mainly for lucky

--! i ripped out basically all the code from L_WallCheck-v1.1.lua, it's way too precise for what i need lol. i just need to check if the wall exists, nothing more !--

addHook("PlayerThink", function(player)
    if player and player.valid
        player.khaos.wallblock = $ or 0
        if player.khaos.wallblock then player.khaos.wallblock = $-1 end
    end
end)


addHook("MobjMoveBlocked", function(mo,mobj,line)
    if mo and mo.valid
    and not (mobj and mobj.valid and mobj.flags & (MF_MONITOR|MF_ENEMY|MF_BOSS))
        if line and line.valid
            if mo.player and mo.player.valid
                if mo.player.khaos.wallblock < 2 then
                    mo.player.khaos.wallblock = TICRATE
                end
            end
        elseif mobj and mobj.valid
            if mo.player.khaos.wallblock < 2 then
                mo.player.khaos.wallblock = TICRATE
            end
        end
    end
end,
MT_PLAYER)

addHook("MobjMoveBlocked", function(mo,mobj,line)
    if mo and mo.valid
    and not (mobj and mobj.valid and mobj.flags & (MF_MONITOR|MF_ENEMY|MF_BOSS))
        if line and line.valid
            if mo and mo.valid
                if not mo.wallblock or mo.wallblock < 2 then
                    mo.wallblock = TICRATE
                    mo.angle = $ + ANGLE_180
                end
            end
        elseif mobj and mobj.valid
            if mo.wallblock < 2 then
                mo.wallblock = TICRATE
            end
        end
    end
end,
MT_CHAOSFROG)

--mobj_ringspill.lua, made by EeveeEuphoria. though, it's also mostly ported from SRB2 source code.

local FINEANGLES = 8192
local FINEMASK = FINEANGLES - 1
local ANGLETOFINESHIFT = 19

--ANG1 = 11930465

rawset(_G, "A_KhaosMobjRingBurst", function(actor, var1, var2) 	-- use var2 for amount of time to collect rings, if set to 0 it's 8 seconds, the default amount;
    --[[if var2
        S_StartSound(actor.tracer, sfx_sttb3)
    else
        S_StartSound(actor, sfx_s3kb9)
    end]]

    if not var2 var2 = 8 end


    local i
    local mo
    local fa, va
    local ns
    local z
    local nightsreplace = ((maptol & TOL_NIGHTS) and not G_IsSpecialStage(gamemap))

    -- Better safe than sorry.
    if not actor
        --print("no actor!")
        return
    end

    if (var1 > 32)
        var1 = 32
    end

    if (abs(actor.momx) > actor.scale or abs(actor.momy) > actor.scale)
        va = R_PointToAngle2(actor.momx, actor.momy, 0, 0)>>ANGLETOFINESHIFT
    else
        va = actor.angle>>ANGLETOFINESHIFT
    end

    for i = var1, 1, -1 do
        --print("gamer " .. i)
        local objType = mobjinfo[MT_RING].reactiontime
        if (mariomode)
            objType = mobjinfo[MT_COIN].reactiontime
        end

        z = actor.z
        if (actor.eflags & MFE_VERTICALFLIP)
            z = $ + (actor.height - mobjinfo[objType].height)
        end

        mo = P_SpawnMobj(actor.x, actor.y, z, objType)

        mo.fuse = var2*TICRATE
        mo.target = actor

        mo.destscale = actor.scale
        mo.scale = actor.scale

        -- Angle offset by player angle, then slightly offset by amount of rings
        --fa = ((i*FINEANGLES/16) + va - ((var1-1)*FINEANGLES/32)) & FINEMASK
        fa = (((i*FINEANGLES/16) + va - ((var1-1)*FINEANGLES/32)) & FINEMASK) * ANG1

        -- Make rings spill out around the player in 16 directions like SA, but spill like Sonic 2.
        -- Technically a non-SA way of spilling rings. They just so happen to be a little similar.
        local momxy
        local momz -- base horizonal/vertical thrusts

        if (i > 15)
            momxy = 3*FRACUNIT
            momz = 4*FRACUNIT
        else
            momxy = 2*FRACUNIT
            momz = 3*FRACUNIT
        end

        ns = FixedMul(FixedMul(momxy, FRACUNIT + FixedDiv((TICRATE/2)<<FRACBITS, 10*TICRATE<<FRACBITS)), mo.scale)
        mo.momx = FixedMul(cos(fa),ns)

        if (not twodlevel or (actor.flags2 & MF2_TWOD))
            mo.momy = FixedMul(sin(fa),ns)
        end

        ns = FixedMul(momz, FRACUNIT + FixedDiv((TICRATE/2)<<FRACBITS, 10*TICRATE<<FRACBITS))
        P_SetObjectMomZ(mo, ns, false)

        if (i & 1)
            P_SetObjectMomZ(mo, ns, true)
        end
    end

    if (actor.eflags & MFE_VERTICALFLIP)
        mo.momz = $ * -1
    end

    return
end)

-- !! snippet of code from Ringslinger Revolution, by MIDIMan !! --

local function Valid(thing)
    return (thing and thing.valid)
end

-- Based off of Snap's code
local function AngleTowardsAngle(angle, destAngle, maxTurn)
	angle = $ or 0
	destAngle = $ or 0
	if maxTurn == nil then maxTurn = ANGLE_22h end
	maxTurn = AngleFixed($)
	if maxTurn > 180*FRACUNIT then
		maxTurn = $ - 360*FRACUNIT
	end

	local delta = AngleFixed(angle - destAngle)
	if delta > 180*FRACUNIT then
		delta = $ - 360*FRACUNIT
	end

	if maxTurn < abs(delta) then
		if delta > 0 then
			angle = $ - FixedAngle(maxTurn)
		else
			angle = $ + FixedAngle(maxTurn)
		end
	else
		angle = destAngle
	end

	return angle
end

local function HomingRingAngleCheck(missile, enemy)
	if not (Valid(missile) and Valid(enemy)) then return end

	-- Don't target enemies outside the missile's angle search!
	local angleTo = R_PointToAngle2(missile.x, missile.y, enemy.x, enemy.y)
	local distTo = R_PointToDist2(missile.x, missile.y, enemy.x, enemy.y)
	local pitchTo = R_PointToDist2(0, missile.z + missile.height/2, distTo, enemy.z + enemy.height/2)
	local angleDelta = AngleFixed(angleTo - missile.angle)
	local pitchDelta = AngleFixed(pitchTo - missile.pitch)

	if angleDelta > 180*FRACUNIT then angleDelta = $ - 360*FRACUNIT end
	if pitchDelta > 180*FRACUNIT then pitchDelta = $ - 360*FRACUNIT end

	if abs(angleDelta) > 30*FRACUNIT then return end
	if abs(pitchDelta) > 30*FRACUNIT then return end

	return true
end

local function PlayersAreTeammates(player, player2)
	if not (Valid(player) and Valid(player2)) then return end

	-- If both players have a ctfteam value greater than 0 and are equal, they are teammates
	if player.ctfteam and player2.ctfteam and player.ctfteam == player2.ctfteam then return true end

	-- Otherwise, they are NOT teammates
	return false
end


addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
	if not (mo.flags & MF_MISSILE) then return end
    if not mo.chaoshome then return end

	local tracer = mo.tracer
	if not (Valid(tracer) and tracer.health > 0) then
		local radius = 512*mo.scale -- TODO: Make this bigger?
		local xShift = FixedMul(radius/2, cos(mo.angle))
		local yShift = FixedMul(radius/2, sin(mo.angle))
		local x1 = mo.x + xShift - radius
		local x2 = mo.x + xShift + radius
		local y1 = mo.y + yShift - radius
		local y2 = mo.y + yShift + radius

		local bestDist = 2*radius
		local bestTracer = nil
		local bestDistEnemy = 2*radius
		local bestTracerEnemy = nil

		searchBlockmap("objects", function(missile, enemy)
			if not (Valid(missile) and Valid(enemy) and enemy.health > 0) then return end
			if missile.target == enemy then return end -- Don't target the projectile's source
			if not (enemy.flags & MF_SHOOTABLE) then return end
            if (enemy.flags & MF_MONITOR) then return end -- rings don't affect monitors, and i'm too lazy to figure out how RSR makes it work
-- 			if not Valid(enemy.player) then return end -- Only target players!

			if not P_CheckSight(missile, enemy) then return end -- Don't target enemies outside the missile's view!
			-- Don't target teammates
			if Valid(missile.target) and Valid(missile.target.player) and Valid(enemy.player) then
				if PlayersAreTeammates(missile.target.player, enemy.player) or (gametyperules & GTR_FRIENDLY) then return end
			end

			-- Don't target enemies outside the missile's distance search!
			local dist = FixedHypot(FixedHypot(enemy.x - missile.x, enemy.y - missile.y), enemy.z - missile.z)
			if dist <= bestDist and HomingRingAngleCheck(missile, enemy) then
				bestDist = dist
				bestTracer = enemy
			end

			if ((enemy.flags & MF_ENEMY) or Valid(enemy.player))
			and dist <= bestDistEnemy and HomingRingAngleCheck(missile, enemy) then
				bestDistEnemy = dist
				bestTracerEnemy = enemy
			end
		end, mo, x1, x2, y1, y2)
		-- Prioritize enemies and non-teammate players over other shootables
		if Valid(bestTracerEnemy) then
			mo.tracer = bestTracerEnemy
			return
		end
		mo.tracer = bestTracer
		return
	end

	local player = mo.tracer.player

	local angleTurn = ANGLE_22h
	if Valid(player) then
		angleTurn = FixedAngle(5*FRACUNIT)
	end
	local angleTo = R_PointToAngle2(mo.x, mo.y, tracer.x, tracer.y)
	local distTo = R_PointToDist2(mo.x, mo.y, tracer.x, tracer.y)
	local pitchTo = R_PointToAngle2(0, mo.z + mo.height/2, distTo, tracer.z + tracer.height/2)

	mo.angle = AngleTowardsAngle($, angleTo, angleTurn)
	mo.pitch = AngleTowardsAngle($, pitchTo, angleTurn)

	local curSpeed = FixedHypot(FixedHypot(mo.momx, mo.momy), mo.momz)
	local speed = mo.info.speed
	if Valid(player) then -- Try to catch up with players, similar to the Deton
		speed = 3*player.normalspeed/4
	end
	if curSpeed < speed then
		curSpeed = speed
	end

-- 	angleTo = mo.angle
	P_InstaThrust(mo, mo.angle, FixedMul(cos(mo.pitch), curSpeed))
-- 	mo.momx = FixedMul(speed, FixedMul(cos(mo.angle), cos(mo.pitch)))
-- 	mo.momy = FixedMul(speed, FixedMul(sin(mo.angle), cos(mo.pitch)))
-- 	mo.momz = FixedMul(speed, sin(mo.pitch))
	mo.momz = FixedMul(sin(mo.pitch), curSpeed)
end, MT_REDRING)

addHook("TouchSpecial", function(special, toucher)
    if not toucher.player or not toucher.player.khaossp then
        return true
    end
    local player = toucher.player
    if player.bot then
        return true
    end

    if special.fade then return true end

    S_StartSound(player.mo, sfx_addfil)
    player.khaossp.hovercard = true
    SRB2CE.addHUDText(player, "\201\199" + "Hover Card" + "\200 \x80" + "collected!", true)
    special.fade = true

    return true
end, MT_CHAOSCARD)

addHook("MobjThinker", function(mobj)
    A_GoldMonitorSparkle(mobj)
    mobj.angle = $ + ANG2 + ANG1
    if not S_OriginPlaying(mobj) then
        S_StartSoundAtVolume(mobj, sfx_chwarp, 90)
    end
    if mobj.fade then
        mobj.alpha = $ - FRACUNIT/45
        mobj.angle = $ + ANG2 + ANG1 -- double speed
        mobj.risemomz = $ and $ + FRACUNIT/4 or FRACUNIT/4
        mobj.scale = max(FRACUNIT/3, $ - FRACUNIT/50)
        mobj.momz = mobj.risemomz
        if mobj.alpha <= 0 then
            P_RemoveMobj(mobj)
        end
    end
end, MT_CHAOSCARD)

